<?php
/**
 * The template used for displaying page content in page.php
 *
 * @package options_sample
 */
$post_id = $post->ID;
$layout = meta::get_meta($post_id, 'layout');

if(isset($layout['type']) && $layout['type'] != 'full'){
	$content_width_class = tools::primary_class($post_id, 'pages', $return_just_class = true);
}else{
	$content_width_class = tools::primary_class(0, 'pages', $return_just_class = true);
}
$flo_title_color = meta::get_meta($post->ID, 'flo_posts_title_color');
if(isset($flo_title_color) && $flo_title_color != '' && $flo_title_color != null){
	$flo_title_color = $flo_title_color;
}else{
	$flo_title_color = '';
}
$meta = meta::get_meta($post_id, 'settings');
$show_header = $meta['page_title'];
$decoration = meta::get_meta($post->ID, 'uploader_custom');
$decor_image = get_post($decoration);

$decor_image_src  = aq_resize($decor_image->guid, 200, 200, true, true, false);
?>

<?php
$email = get_post_meta( $post_id, 'flo_contacts_email', true );
$thx_msg = get_post_meta( $post_id, 'flo_contacts_thx_msg', true );
$title =  get_post_meta( $post_id, 'flo_contacts_form_title', true );
$description = get_post_meta( $post_id, 'flo_contacts_form_description', true );

$feat_enabled = false;

if (has_post_thumbnail($post->ID) && !post_password_required()) {
	$feat_enabled = true;
	$src = wp_get_attachment_url(get_post_thumbnail_id($post->ID), 'full'); //get img URL
	$img_url = aq_resize($src, '99999', '400', true, true); //crop img

	if(isset($img_url) && $img_url != ''){
		?>
		<div id="post-<?php the_ID(); ?>" <?php post_class('row header'); ?>>
			<div class="columns medium-12  page-featured-image">
				<figure>
					<?php if(isset($img_url) && $img_url != ''){?>
						<img src="<?php echo $img_url;?>" alt="">
					<?php }?>
					<!-- If Title is on Featured image-->
					<div class="figure-hover">
						<?php if ($show_header == 'yes'): ?>
							<div class="page-header">
								<h1 class="page-title entry-title" style="color: <?php echo $flo_title_color;?>"><?php echo flo_title( $post->ID); ?></h1>
							</div>
						<?php endif ?>
					</div>
				</figure>
			</div>
		</div>
	<?php } 

}else{
	$img_url = '';
}

?>


<div class="row">
	<div class="columns small-12 page-content">
		<div class="inner">
			<?php if(isset($decor_image_src) && $decor_image_src != ''):?>

				<div class="page-header">
					<div class="header-icon"><img src="<?php echo $decor_image_src; ?>" alt=""></div>
				</div>
				
			<?php endif;?>

			<article class="content entry-content">

		<?php the_content(); ?>

		</article>
		<?php if (is_email( $email )): ?>

		<div class="inner">
			<?php if(isset($title) && $title != '' && $title != null){?><h1 class="page-title entry-title"><?php echo $title;?></h1><?php }?>
			<div class="contact-form-template">
				<div class="row">
					<div class="columns medium-8 medium-push-2">
						<?php if(isset($description) && $description != '' && $description != null){?><div class="excerpt"><?php echo $description;?></div><?php }?>

						<form id="cosmo-contact-form" class="contact-inputs" method="post">
							<div class="row">
								<div class="columns medium-6">
									<input id="cosmo-name" placeholder="<?php _e('Name *', 'flotheme'); ?>" name="cosmo-name" type="text" value="" aria-required="true">
									<input id="cosmo-email" placeholder="<?php _e('Email Address *', 'flotheme'); ?>" name="cosmo-email" type="email" value="" aria-required="true">
									<input id="cosmo-subject" placeholder="<?php _e('Subject', 'flotheme'); ?>" name="cosmo-subject" type="text" value="" aria-required="false">
								</div>
								<div class="columns medium-6">
									<textarea id="cosmo-message" name="cosmo-message" placeholder="<?php _e('Message', 'flotheme'); ?> "></textarea>
								</div>
								<input type="hidden" name="cosmo-contact-email" value="<?php echo $email; ?>">
								<input type="hidden" name="thx_msg" value="<?php echo urlencode($thx_msg); ?>">
							</div>
							<input type="button" value="<?php _e('Submit form', 'flotheme'); ?>" id="cosmo-send-msg" name="btn_submit" onclick="cosmoSendMail( '#cosmo-contact-form' , 'div#cosmo_contact_response' );">
							<div id="cosmo_contact_response"></div>
						</form>
					</div>
				</div>
				<div class="contact-social">
					<?php get_template_part("/parts/social_links"); ?>
					<?php if (is_email( $email )): ?>
						<div class="contact-form-template">
							<div class="email"> <?php _e('Email:','flotheme') ?>  <a href="mailto:<?php echo $email ?>" target="_blank"> <?php echo $email ?></a></div>
						</div>
					<?php endif ?>
				</div>
			</div>

			
		</div>

		<?php else: ?>
			<?php _e('Enter please a valid Contact email address','flotheme'); ?>
		<?php endif ?>

	</div>
</div>

</div>
