<?php
global $flo_options, $meta, $meta_repeater_show, $sidebar_sharing,$page_about, $page_type_class;
$post_id = $post->ID;
$layout = meta::get_meta($post_id, 'layout');
$flo_title_color = meta::get_meta($post->ID, 'flo_posts_title_color');
if(isset($flo_title_color) && $flo_title_color != '' && $flo_title_color != null){
	$flo_title_color = 'style="color: '.$flo_title_color.';"' ;
}else{
	$flo_title_color = '';
}
if (isset($layout['type']) && $layout['type'] != 'full') {
	$content_width_class = tools::primary_class($post_id, 'pages', $return_just_class = true);
} else {
	$content_width_class = tools::primary_class(0, 'pages', $return_just_class = true);
}
//added this code for to get the global $meta_repeater_show
ob_start();
ob_clean();
layout::side('right', $post_id, 'pages');
layout::side('left', $post_id, 'pages');
$side = ob_get_clean();

ob_start();
ob_clean();
get_template_part('parts/comment-block');
$comments = ob_get_clean();

$feat_enabled = false;
$meta = meta::get_meta($post->ID, 'settings');
if(isset($meta['page_title'])){
	$show_header = $meta['page_title'];
}else{
	$show_header = true;
}


$img_url = null;
$page_comments = $flo_options['flo-page_comments'];
$is_featured_image = false;
$is_content = get_the_content();

 $decoration = meta::get_meta($post->ID, 'uploader_custom');
 $decor_image = get_post($decoration);

$decor_image_src  = aq_resize($decor_image->guid, 200, 200, true, true, false);

if(isset($meta) && isset($meta['title_under_image']) && $meta['title_under_image'] == 'yes' && $page_type_class != 'content-80'){
	$title_under_image = true;
}else{
	$title_under_image = false;
}
?>


<?php if (has_post_thumbnail($post->ID) && !post_password_required()): ?>
	<?php
	$feat_enabled = true;
	$src          = wp_get_attachment_url(get_post_thumbnail_id($post->ID), 'full'); //get img URL
	$img_url      = aq_resize($src, '1800', '500', true, true); //crop img
	$is_featured_image = isset($img_url) && $img_url != '';
	?>
	<?php if ($is_featured_image): ?>

		<div id="post-<?php the_ID(); ?>" <?php post_class('row header'); ?>>
			<div class="columns medium-12  page-featured-image">
				<figure>
					<?php if (isset($img_url) && $img_url != ''): ?>
						<img src="<?php echo $img_url; ?>" alt="">
					<?php endif; ?>

					<!-- If Title is on Featured image-->
					<?php if($page_type_class != 'content-80' && $title_under_image != true):?>
						<style type="text/css">
							.sub-title {
								color: <?php echo meta::get_meta($post->ID, 'flo_posts_title_color');?>;
							}
						</style>
						<div class="figure-hover">
							<?php if ($show_header == 'yes'):?>
								<h1 class="page-title" <?php echo $flo_title_color; ?> ><?php echo flo_title($post->ID); ?></h1>
							<?php endif;?>
						</div>
					<?php endif;?>
				</figure>
			</div>
		</div>
	<?php endif; ?>
<?php endif; ?>

<div class="row">
	<div class="columns small-12 <?php echo $content_width_class; ?> <?php echo $is_featured_image ? 'with-image' : ''; echo !$is_content ? ' without-content' : '';?> page-content">
		<?php if ( ($show_header == 'yes') || (strlen(get_the_content())) ): ?>

		<div class="inner">
			<?php if (($show_header == 'yes' && ($page_type_class == 'content-80' || !$is_featured_image  ) ) || $title_under_image == true ): ?>
				<div class="page-header text-center">
					<h1 class="page-title entry-title"><?php echo flo_title($post->ID); ?></h1>
				</div>
			<?php endif; ?>
			<article class="content entry-content">


				<?php the_content(); ?>
				<?php if(!isset($meta_repeater_show) || $meta_repeater_show == false):?>
					<?php echo get_template_part('parts/meta-single'); ?>
				<?php endif; ?>

				<?php
				wp_link_pages(array(
						'before' => '<div class="page-links">' . __('Pages:', 'flotheme'),
						'after'  => '</div>',
				));
				?>
				<?php if(!$sidebar_sharing && (!comments_open() || !get_comments_number())  && $page_comments != '1' && $flo_options['flo-social_for_pages'] == '1'):
					$page_about = true;
					?>
					<?php echo get_template_part('parts/social-sharing');?>
				<?php endif?>
			</article>

			<footer class="entry-footer1">
				<?php edit_post_link(__('Edit', 'flotheme'), '<span class="edit-link">', '</span>'); ?>
			</footer>

		</div>

		<?php endif ?>

		<?php  

			if (isset($meta['include_below_page_content_sidebar']) && $meta['include_below_page_content_sidebar'] == 'yes') {
				get_template_part('parts/post/block-below-page-content');
			}
		$en_comments = $flo_options['flo-comments']['Enabled'];
		?>
		<?php if ( (comments_open() || get_comments_number() ) && $page_comments == '1' && count($en_comments) > 1) : ?>
			<?php
			/* comments */
			?>
			<div class="row">
				<?php

				if(isset($layout['type']) && $layout['type'] != 'full'){
					$comment_class = 'medium-12';
				}else{
					$comment_class = 'medium-10 push-1';
				}
				?>
				<div class="columns <?php echo $comment_class;?>">
					<?php echo get_template_part('parts/comment-block');?>
				</div>

			</div>

		<?php endif;?>
	</div>
<?php
	layout::side('right', $post_id, 'pages');
	layout::side('left', $post_id, 'pages');
?>
</div>
