<?php
if (file_exists(dirname(__FILE__) . '/../../cmb2/init.php')) {
    require_once dirname(__FILE__) . '/../../cmb2/init.php';
} elseif (file_exists(dirname(__FILE__) . '/../../CMB2/init.php')) {
    require_once dirname(__FILE__) . '/../../cmb2/init.php';
}

add_action('cmb2_init', 'yourprefix_register_repeatable_group_field_metabox');


/**
 * Hook in and add a metabox to demonstrate repeatable grouped fields
 */
function yourprefix_register_repeatable_group_field_metabox()
{

    if(is_admin()){
        wp_register_style('fancybox_meta', get_template_directory_uri() . '/flo-options/ReduxCore/assets/js/fancybox/jquery.fancybox.css');
        wp_enqueue_style('fancybox_meta');


        wp_register_script('fancybox_meta', get_template_directory_uri() . '/flo-options/ReduxCore/assets/js/fancybox/jquery.fancybox.pack.js');
        wp_enqueue_script('fancybox_meta');
    }

    // Start with an underscore to hide fields from custom fields list
    $prefix = 'flo_repeater_';
    /**
     * Repeatable Field Groups
     */
    $cmb_group = new_cmb2_box(array(
        'id' => $prefix . 'metabox',
        'title' => __('Info text sidebar.', 'flotheme'),
        'object_types' => array('page','post'),
    ));
    // $group_field_id is the field id string, so in this case: $prefix . 'demo'
    $group_field_id = $cmb_group->add_field(array(
        'id' => $prefix . 'demo',
        'type' => 'group',
        'description' => __('Add your information here:', 'flotheme').'<a href="'.get_template_directory_uri().'/flo-options/ReduxCore/assets/img/help_cmb.jpg" data-fancybox-group="prettyPhoto_7329867942837" class="img-lightbox-hint"><span class="dashicons dashicons-editor-help"></span></a>',
        
        'options' => array(
            'group_title' => __('Block {#}', 'flotheme'), // {#} gets replaced by row number
            'add_button' => __('Add Block', 'flotheme'),
            'remove_button' => __('Remove Block', 'flotheme'),
        ),

    ));
    /**
     * Group fields works the same, except ids only need
     * to be unique to the group. Prefix is not needed.
     *
     * The parent field's id needs to be passed as the first argument.
     */
    $cmb_group->add_group_field($group_field_id, array(
        'name' => __('Block Title', 'flotheme'),
        'id' => 'title',
        'type' => 'text',
//        'repeatable' => true, // Repeatable fields are supported w/in repeatable groups (for most types)
    ));
    $cmb_group->add_group_field($group_field_id, array(
        'name' => __('Description', 'flotheme'),
        'description' => __(' <p>The following format is recommended (one description per line):</p>  <xmp><b>Creative Director:</b> Yossi Fisher <br/></xmp>', 'flotheme'),
        'id' => 'description',
        'type' => 'textarea_small',
//        'repeatable' => true, // Repeatable fields are supported w/in repeatable groups (for most types)
    ));

}

/**
 * Conditionally displays a field when used as a callback in the 'show_on_cb' field parameter
 *
 * @param  CMB2_Field object $field Field object
 *
 * @return bool                     True if metabox should show
 */
function cmb2_hide_if_no_cats($field)
{
// Don't show this field if not in the cats category
    if (!has_tag('cats', $field->object_id)) {
        return false;
    }
    return true;
}

/**
 * Conditionally displays a message if the $post_id is 2
 *
 * @param  array $field_args Array of field parameters
 * @param  CMB2_Field object $field      Field object
 */
function cmb2_before_row_if_2($field_args, $field)
{
    if (2 == $field->object_id) {
        echo '<p>Testing <b>"before_row"</b> parameter (on $post_id 2)</p>';
    } else {
        echo '<p>Testing <b>"before_row"</b> parameter (<b>NOT</b> on $post_id 2)</p>';
    }
}


add_filter('cmb2_meta_boxes', 'latest_posts_metabox');
function load_js()
{
    if (is_admin()) {


//        wp_enqueue_script( 'jquery' );



        wp_register_script('meta', get_template_directory_uri() . '/flo-options/ReduxCore/assets/js/meta.js');
        wp_enqueue_script('meta');
        wp_register_script('extra', get_template_directory_uri() . '/flo-options/ReduxCore/assets/js/extra.js');
        wp_enqueue_script('extra');

        wp_register_script('actions', get_template_directory_uri() . '/flo-options/ReduxCore/assets/js/actions.js');
        wp_enqueue_script( 'jquery' );
        wp_enqueue_script('media-upload');
        wp_enqueue_script('thickbox');
        wp_enqueue_script( 'jquery-ui-autocomplete' ); // for autocomplete search
        wp_enqueue_script( 'actions' );

//        wp_enqueue_script( 'jquery-ui-autocomplete' ); // for autocomplete search
        wp_enqueue_style(
            'generic-fields',
            get_template_directory_uri() . '/flo-options/ReduxCore/assets/css/generic-fields.css');
//        $siteurl = get_option('siteurl');
    }
}



add_action('admin_init', 'load_js', 1);


/**
 * Define the metabox and field configurations.
 *
 * @param  array $meta_boxes
 * @return array
 */
function latest_posts_metabox(array $meta_boxes)
{

// Start with an underscore to hide fields from custom fields list
    $prefix = '_cmb2_';

    /**
     * Sample metabox to demonstrate each field type included
     */
    $gutter_options = array(
        'gutter-default'  => __('Default 30px', 'flotheme'),
        'gutter-0'           => __('No gutter', 'flotheme'),
        'gutter-2'  => __('Gutter 2px', 'flotheme'),
        'gutter-5'  => __('Gutter 5px', 'flotheme'),
        'gutter-10'  => __('Gutter 10px', 'flotheme'),
        'gutter-20'  => __('Gutter 20px', 'flotheme'),
        'gutter-40'  => __('Gutter 40px', 'flotheme'),
        'gutter-50'  => __('Gutter 50px', 'flotheme'),
    );
//    $view_type = array(
//        'thumb_view_title_over' => 'contact_1.png',
//        'grid_view' => 'contact_2.png',
//        'grid_50_50' => 'contact_3.png',
//        'grid_mosaic' => 'contact_3.png',
//        'list_view_50_50' => 'contact_3.png',
//        'thumb_view_title_below' => 'contact_3.png',
//        'grid_view_featured_post' => 'contact_3.png'
//    );
//	src="http://flo_themes.local/wp-content/themes/porto/flo-options/ReduxCore/assets/img/pattern/http://flo_themes.local/wp-content/themes/porto/flo-options/ReduxCore/assets/img/icons/grid1.png"
	$view_type        = array(
			'thumb_view_title_over'   =>  '../icons/grid1.png',
			'grid_view'               =>  '../icons/grid2.png',
			'grid_50_50'              =>  '../icons/grid3.png',
			'grid_mosaic'             =>  '../icons/grid4.png',
			'list_view_50_50'         =>  '../icons/grid5.png',
			//'thumb_view_title_below'  =>  '../icons/grid6.png',
			'grid_view_featured_post' =>  '../icons/grid7.png',
			//'grid_pattern'            =>  '../icons/grid8.png',
	);
	$view_type_gallery = array(
			'two_columns' => '../icons/gallery1.png',
			'horizontal_long' => '../icons/gallery3.png',
			'fixed_with_thumbs' => '../icons/gallery2.png',
			'one_line' => '../icons/single2.png',
	);
    $post_categories = get_terms('category');
    $post_category_array = array();
    foreach($post_categories as $cat_p){
        array_push($post_category_array,$cat_p->name , $cat_p->name);
    }
    $gallery_categories = get_terms('gallery-category');
    $gallery_category_array = array();
    foreach($gallery_categories as $cat_g){
        array_push($gallery_category_array,$cat_g->name , $cat_g->name);
    }

    $all_pages = get_pages();
    $pages_array = array();
    foreach ($all_pages as $key => $the_page) {
        $pages_array[$the_page->ID] = $the_page->post_title;
    }


    $meta_boxes['latest_posts'] = array(
        'id' => 'latest_posts',
        'title' => __('Latest Posts', 'flotheme'),
        'type' => 'group_field',
        'object_types' => array('page'), // Post type
        'context' => 'normal',
        'priority' => 'high',
        'show_names' => true, // Show field names on the left
        'fields' => array(
            array(
                'name' => __('Select Post Type', 'flotheme'),
                'desc' => __('Select post type', 'flotheme'),
                'id' => $prefix . 'post_type',
                'type' => 'select',
                'options' => array(
                    'post' => __('Posts', 'flotheme'),
                    'gallery' => __('Galleries', 'flotheme'),
                    'page' => __('Pages', 'flotheme'),
                ),
            ),
            array(
                'name' => __('Select Post Category', 'flotheme'),
                'desc' => __('Select Post Category', 'flotheme'),
                'id' => $prefix . 'category_p',
                //'taxonomy' => 'category', // Taxonomy Slug
                'type' => 'multicheck',
                'options' => flo_get_taxonomy_array('category'),
                'dependence_parent_id' => $prefix . 'post_type',
                'dependence_option_index' =>'post', //  make sure you add the necessary code in cmb2/js/cmb2.min.js
            ),
            array(
                'name' => __('Select Gallery Category', 'flotheme'),
                'desc' => __('Select Gallery Category', 'flotheme'),
                'id' => $prefix . 'category_g',
                //'type' => 'taxonomy_multicheck',
                'type' => 'multicheck',
                'options' => flo_get_taxonomy_array('gallery-category'),
                //'taxonomy' => 'gallery-category', // Taxonomy Slug
                'dependence_parent_id' => $prefix . 'post_type',
                'dependence_option_index' =>'gallery', //  make sure you add the necessary code in cmb2/js/cmb2.min.js
            ),

            array(
                'name'    => __('Select Pages', 'flotheme'),
                'desc'    => __('Select Pages', 'flotheme'),
                'id'      => $prefix . 'page_ids',
                'type'    => 'multicheck',
                'options' => $pages_array,
                'dependence_parent_id' => $prefix . 'post_type',
                'dependence_option_index' =>'page' //  make sure you add the necessary code in cmb2/js/cmb2.min.js
            ),
            

            array(
                'name' => __('View type', 'flotheme'),
                'desc' => __('Select view type', 'flotheme'),
                'id' => $prefix . 'view_type',
                'type' => 'grid_radio',
                'options' => array(
                    'thumb_view_title_over' => __('Thumbnail view title on hover', 'flotheme'),
                    'grid_view' => __('Grid view', 'flotheme'),
                    'grid_50_50' => __('Grid 50x50', 'flotheme'),
                    'grid_mosaic' => __('Mosaic grid', 'flotheme'),
                    'list_view_50_50' => __('List view 50x50', 'flotheme'),
                    //'thumb_view_title_below' => __('Thumbnail view title below', 'flotheme'),
                    'grid_view_featured_post' => __('Grid view with featured post', 'flotheme'),
                    //'grid_pattern' => __('Grid view pattern', 'flotheme'),
                ),
                'value' => $view_type,
                'path' => 'pattern/',
            ),
            array(
                'name' => __('Number of posts', 'flotheme'),
                'desc' => __('Enter number of posts (numeric)', 'flotheme'),
                'id' => $prefix . 'nr_of_posts',
                'type' => 'text',
                'dependence_parent_id' => $prefix . 'view_type',
                'dependence_option_index' =>array('1','2','3','4','5','6'),
            ),

            array(
                'name' => __('Select Featured post', 'flotheme'),
                'desc' => __('Select Featured post', 'flotheme'),
                'id' => $prefix . 'feat_post',
                'type' => 'post_search_text',
                'dependence_parent_id' => $prefix . 'view_type',
                'dependence_option_index' =>array('6'),
            ),
            array(
                'name' => __('Number of columns', 'flotheme'),
                'desc' => __('Select number of columns.', 'flotheme'),
                'id' => $prefix . 'nr_of_columns',
                'type' => 'select',
                'options' => array(
                    '1' => 'One Column',
                    '2' => 'Two Columns',
                    '3' => 'Three Columns',
                    '4' => 'Four Columns',
                    '6' => 'Six Columns',
                ),
                'dependence_parent_id' => $prefix . 'view_type',
                'dependence_option_index' =>array('1','2'),
            ),
		        array(
				        'name' => __('Number of columns', 'flotheme'),
				        'desc' => __('Select number of columns.', 'flotheme'),
				        'id' => $prefix . 'nr_of_columns_grid_50_50',
				        'type' => 'select',
				        'options' => array(
						        '1' => 'One Column',
						        '2' => 'Two Columns',
						        '3' => 'Three Columns',
				        ),
				        'dependence_parent_id' => $prefix . 'view_type',
				        'dependence_option_index' =>array('3'),
		        ),

            array(
                'name' => __('Number of columns', 'flotheme'),
                'desc' => __('Select number of columns.', 'flotheme'),
                'id' => $prefix . 'nr_of_columns_featured',
                'type' => 'select',
                'options' => array(
                    '3' => 'Three Columns',
                    '4' => 'Four Columns',
                    '6' => 'Six Columns',
                ),
                'dependence_parent_id' => $prefix . 'view_type',
                'dependence_option_index' =>array('6'),
            ),
		        // array(
				      //   'name' => __('Number of columns', 'flotheme'),
				      //   'desc' => __('Select number of columns.', 'flotheme'),
				      //   'id' => $prefix . 'nr_of_columns_grid_title_below',
				      //   'type' => 'select',
				      //   'options' => array(
						    //     '1' => 'One Column',
						    //     '2' => 'Two Columns',
						    //     '3' => 'Three Columns',
						    //     '4' => 'Four Columns',
				      //   ),
				      //   'dependence_parent_id' => $prefix . 'view_type',
				      //   'dependence_option_index' =>array('6'),
		        // ),

            array(
                'name' => __('Gutter type', 'flotheme'),
                'desc' => __('Select gutter type (in px).', 'flotheme'),
                'id' => $prefix . 'gutter',
                'type' => 'select',
                'options' => $gutter_options,
                'dependence_parent_id' => $prefix . 'view_type',
                'dependence_option_index' =>array('1','2','3','6'),
            ),
	        array(
		        'name' => __('Enable masonry?', 'flotheme'),
		        'desc' => __('Enable masonry ?', 'flotheme'),
		        'id' => $prefix . 'masonry',
		        'type' => 'select',
		        'options' => array(
				        'no' => 'No',
				        'yes' => 'Yes',
		        ),
		        'default' => 'no',
		        'dependence_parent_id' => $prefix . 'view_type',
		        'dependence_option_index' => array('2'),
	        ),
            array(
                'name' => __('Enable pagination ?', 'flotheme'),
                'desc' => __('Enable pagination ?', 'flotheme'),
                'id' => $prefix . 'pagination',
                'type' => 'select',
                'options' => array(
                    'yes' => 'Yes',
                    'no' => 'No'
                ),
                'dependence_parent_id' => $prefix . 'view_type',
                'dependence_option_index' =>array('1','2','3','4','5','6'),
            )

        ),
    );

	$meta_boxes['gallery'] = array(
			'id' => 'latest_galleries',
			'title' => __('Gallery', 'flotheme'),
			'object_types' => array('page'), // Post type
			'context' => 'normal',
			'priority' => 'high',
			'show_names' => true, // Show field names on the left
			'fields' => array(
					array(
							'name' => __('Select Gallery', 'flotheme'),
							'desc' => __('Select Gallery', 'flotheme'),
							'id' => $prefix . 'gallery',
							'type' => 'gallery_search_text',
					),
			),
	);

	$meta_boxes['gallery_single'] = array(
			'id' => 'single_galleries',
			'title' => __('Gallery', 'flotheme'),
			'object_types' => array('gallery'), // Post type
			'context' => 'normal',
			'priority' => 'high',
			'show_names' => true, // Show field names on the left
			'fields' => array(
					array(
							'name' => __('View type', 'flotheme'),
							'desc' => __('Select view type', 'flotheme'),
							'id' => $prefix . 'gallery_view_type',
							'type' => 'grid_radio',
							'options' => array(
									'two_columns' => __('Gallery two columns', 'flotheme'),
									'horizontal_long' => __('Gallery horizontal long', 'flotheme'),
									'fixed_with_thumbs' => __('Gallery fixed with thumbs', 'flotheme'),
									'one_line' => __('Gallery one line', 'flotheme'),
							),
							'value' => $view_type_gallery,
							'path' => 'pattern/',
					),
			),
	);

// Add other metaboxes as needed
    return $meta_boxes;
}

function cmb2_post_search_render_field( $field, $escaped_value, $object_id, $object_type, $field_type ) {
    $select_type = $field->args( 'select_type' );
    $value = get_post_meta($object_id,$field->args('value'));
    if(isset($value['_cmb2_feat_post'])){
	    $val = $value['_cmb2_feat_post'];
    }else{
	    $val = '';
    }

    if(isset($val[0])){
        $feat_p = get_post($val[0]);
    }else{
        $feat_p = get_post(0);
    }
    $post_type = 'post';
    $post_status = 'publish';
    echo $field_type->input( array(
        'data-posttype'   => $field->args( 'post_type' ),
        'data-selecttype' => 'radio' == $select_type ? 'radio' : 'checkbox',
        'class' => 'ui-autocomplete-input',
        'value' => $feat_p->post_title
    ) );
    echo $field_type->input( array(
        'type' => 'hidden',
        'value' => 'post',
        'class' => 'generic-params',
        'desc' => ''

    ) );
    $unique_id = mt_rand(0,9999);
    echo $field_type->input( array(
        'type' => 'hidden',
        'name' => $field->args('id'),
        'class' => 'generic-record generic-value u-class-'.$unique_id,
        'desc' => ''
    ) );
}
add_action( 'cmb2_render_post_search_text', 'cmb2_post_search_render_field', 10, 5 );


function cmb2_gallery_search_render_field( $field, $escaped_value, $object_id, $object_type, $field_type ) {
	$select_type = $field->args( 'select_type' );
	$value = get_post_meta($object_id,$field->args('value'));
	if(isset($value['_cmb2_gallery'])){
		$val = $value['_cmb2_gallery'];
	}else{
		$val = '';
	}

    if(isset($val[0])){
        $feat_p = get_post($val[0]);
    }else{
        $feat_p = get_post(0);
    }

	$post_type = 'gallery';
	$post_status = 'publish';
	echo $field_type->input( array(
			'data-posttype'   => $post_type,
			'data-selecttype' => 'radio' == $select_type ? 'radio' : 'checkbox',
			'class' => 'ui-autocomplete-input',
			'value' => $feat_p->post_title
	) );
	echo $field_type->input( array(
			'type' => 'hidden',
			'value' => 'post',
			'class' => 'generic-params',
			'desc' => ''

	) );
	$unique_id = mt_rand(0,9999);
	echo $field_type->input( array(
			'type' => 'hidden',
			'name' => $field->args('id'),
			'class' => 'generic-record generic-value u-class-'.$unique_id,
			'desc' => ''
	) );
}
add_action( 'cmb2_render_gallery_search_text', 'cmb2_gallery_search_render_field', 10, 5 );
/**
 * Set the post type via pre_get_posts
 * @param  array $query  The query instance
 */


add_action( 'cmb2_init', 'register_contact_page_metabox' );
/**
 * Hook in and add a metabox that only appears on the 'About' page
 */
function register_contact_page_metabox() {
//die("sd");
	$prefix = 'flo_contacts_';

	/**
	 * Metabox to be displayed on a single page ID
	 */
	$cmb_about_page = new_cmb2_box( array(
			'id'           => $prefix . 'metabox',
			'title'        => __( 'Contact Page Metabox', 'flotheme' ),
			'object_types' => array( 'page', ), // Post type
            //'show_on'      => array( 'key' => 'page-template', 'value' => 'templates/template-contact-form.php' ),
        	'context'      => 'normal',
			'priority'     => 'high',
			'show_names'   => true, // Show field names on the left
//			'show_on'      => array( 'id' => array( 120, ) ), // Specific post IDs to display this metabox
	) );

    $cmb_about_page->add_field( array(
            'name' => __( 'Email', 'flotheme' ),
            'desc' => __( 'This field  required for contact form.', 'flotheme' ),
            'id'   => $prefix . 'email',
            'type' => 'text_email',
            'attributes'  => array(
                    'placeholder' => 'email',
                    'rows'        => 3,
                    //'required'    => 'required',
            ),
    ) );
	$cmb_about_page->add_field( array(
			'name' => __( 'Form Title!', 'flotheme' ),
			'desc' => __( 'Add form title.', 'flotheme' ),
			'id'   => $prefix . 'form_title',
			'type' => 'text',
	) );
	$cmb_about_page->add_field( array(
			'name' => __( 'Form Description!', 'flotheme' ),
			'desc' => __( 'Add form description.', 'flotheme' ),
			'id'   => $prefix . 'form_description',
			'type' => 'textarea',
	) );

	$cmb_about_page->add_field( array(
			'name' => __( 'Thank you message!', 'flotheme' ),
			'desc' => __( 'Add your "thank you message." .', 'flotheme' ),
			'id'   => $prefix . 'thx_msg',
			'type' => 'textarea',
	) );


}

add_action( 'cmb2_init', 'register_posts_metabox' );
function register_posts_metabox() {
	$prefix = 'flo_posts_';

	/**
	 * Metabox to be displayed on a single page ID
	 */
	$cmb_posts_settings = new_cmb2_box( array(
			'id'           => $prefix . 'metabox',
			'title'        => __( 'Title Color Settings', 'flotheme' ),
			'object_types' => array( 'post','page' ), // Post type
			'context'      => 'normal',
			'priority'     => 'high',
			'show_names'   => true, // Show field names on the left
	) );

	$cmb_posts_settings->add_field( array(
			'name' => __( 'Title Color', 'flotheme' ),
			'desc' => __( 'This field will be used only when featured image is available and displayed on this post/page.', 'flotheme' ),
			'id'   => $prefix . 'title_color',
			'type' => 'colorpicker',
		)
	);
}


add_action( 'cmb2_init', 'register_blog_list_metabox' );
function register_blog_list_metabox() {
	$prefix = '_flo_blog_list_';

	/**
	 * Metabox to be displayed on a single page ID
	 */
	$cmb_posts_settings = new_cmb2_box( array(
			'id'           => $prefix . 'metabox',
			'title'        => __( 'List View Settings', 'flotheme' ),
			'object_types' => array('page' ), // Post type
            'context'      => 'normal',
			'priority'     => 'high',
			'show_names'   => true, // Show field names on the left
	) );

	$cmb_posts_settings->add_field( array(
					'name' => __( 'Number of post', 'flotheme' ),
					'id'   => $prefix . 'nr_of_posts',
					'type' => 'text',
			)
	);

	$cmb_posts_settings->add_field( array(
					'name' => __('Select Post Category', 'flotheme'),
					'desc' => __('Select Post Category', 'flotheme'),
					'id' => $prefix . 'category',
					// 'taxonomy' => 'category', // Taxonomy Slug
					// 'type' => 'taxonomy_multicheck',
                    'type' => 'multicheck',
                    'options' => flo_get_taxonomy_array('category'),
			)
	);
	// $cmb_posts_settings->add_field( array(
	// 				'name' => __('Select Gallery Category', 'flotheme'),
	// 				'desc' => __('Select Gallery Category', 'flotheme'),
	// 				'id' => $prefix . 'category_g',
	// 				'type' => 'taxonomy_multicheck',
	// 				'taxonomy' => 'gallery-category', // Taxonomy Slug
	// 				'dependence_parent_id' => $prefix . 'post_type',
	// 				'dependence_option_index' =>'gallery', //  make sure you add the necessary code in cmb2/js/cmb2.min.js
	// 		)
	// );

}
?>
