<?php
global $flo_options;
function flo_get_logo($mobile = false) {

	global $logo_class, $flo_options;
	$logo_type = $flo_options['flo-logo_type'];

	if ($logo_type == 'image') {
		$slideshow_logo = '';

		if(is_array($flo_options['flo-logo_image_desktop']) && isset($flo_options['flo-logo_image_desktop']['url'])){
			$desktop_logo_img_url = $flo_options['flo-logo_image_desktop']['url'];
		}else if(isset($flo_options['flo-logo_image_desktop']) && is_string($flo_options['flo-logo_image_desktop']) && strlen($flo_options['flo-logo_image_desktop'])){
			// this usually happens when the logo is added via the customizer

			$desktop_logo_img_url = $flo_options['flo-logo_image_desktop'];
		}

		if(isset($desktop_logo_img_url) && strlen($desktop_logo_img_url)){
			$desktop_logo = "<img class='flo-desktop-logo default-logo ' src='" . $desktop_logo_img_url . "' alt='" . get_bloginfo('name') . "' />";
		}else{
			$desktop_logo = '';
		}

		if(is_array($flo_options['flo-logo_image_mobile']) && isset($flo_options['flo-logo_image_mobile']['url'])){
			$mobile_logo_img_url = $flo_options['flo-logo_image_mobile']['url'];
		}else if(isset($flo_options['flo-logo_image_mobile']) && is_string($flo_options['flo-logo_image_mobile']) && strlen($flo_options['flo-logo_image_mobile'])){

			// this usually happens when the logo is added via the customizer
			$mobile_logo_img_url = $flo_options['flo-logo_image_mobile'];
		}

		if(isset($mobile_logo_img_url) && strlen($mobile_logo_img_url)){
			$mobile_logo = "<img class='flo-mobile-logo default-logo ' src='" . $mobile_logo_img_url . "' alt='" . get_bloginfo('name') . "' />";
		}else{
			if(isset($desktop_logo_img_url) && strlen($desktop_logo_img_url)){
				$mobile_logo = "<img class='flo-mobile-logo default-logo ' src='" . $desktop_logo_img_url . "' alt='" . get_bloginfo('name') . "' />";
			}else{
				$mobile_logo = '';
			}
		}


		if (strlen($desktop_logo) || strlen($mobile_logo) ) {
			$logo_class = ' site-logo ';

			if ($mobile == true) {
				$logo = "<a href='" . home_url() . "' class='logo-image logo '> " . $mobile_logo . "</a>";
			} else {
				$logo = "
				<a href='" . home_url() . "' class='logo-image logo '> " . $desktop_logo . "</a>";
			}
			
		} else {
			$logo_class = '  ';
			$logo       = NULL;
		}
		if (!$logo) {
			if ($mobile == true) {
				$logo .= '<h1 class="logo flo-mobile-logo "><a href="' . home_url() . '">' . get_bloginfo('name') . '</a></h1>';
				$logo_class = '  ';
			}else{
				$logo .= '<h1 class="logo "><a href="' . home_url() . '">' . get_bloginfo('name') . '</a></h1>';
				$logo_class = '  ';
			}

		}

	} else {
		$logo_class = '  ';
		$logo       = '<h1 class="logo"><a href="' . home_url() . '" class="logo-image">' . get_bloginfo('name') . '</a></h1>';
	}

	if ($mobile == true) {
		
	}

	return $logo;
}


function addhttp($url)
{
	if (!preg_match("~^(?:f|ht)tps?://~i", $url)) {
		$url = "http://" . $url;
	}
	return $url;
}

/**
 * gallery shortcode using massonry
 *
 * @param string $output
 * @param array $attr
 *
 * @return string
 */
function flo_post_gallery($output, $attr)
{
	global $post, $wp_locale;

	static $instance = 0;
	$instance++;

	if (isset($attr['orderby'])) {
		$attr['orderby'] = sanitize_sql_orderby($attr['orderby']);
		if (!$attr['orderby'])
			unset($attr['orderby']);
	}

	$size = 'large';

	extract(shortcode_atts(array(
			'order'      => 'ASC',
			'orderby'    => 'menu_order ID',
			'id'         => $post->ID,
			'itemtag'    => 'dl',
			'icontag'    => 'dt',
			'captiontag' => 'dd',
			'columns'    => 3,
			'size'       => $size,
			'include'    => '',
			'exclude'    => ''
	), $attr));

	$id = intval($id);
	if ('RAND' == $order)
		$orderby = 'none';

	if (!empty($include)) {
		$include      = preg_replace('/[^0-9,]+/', '', $include);
		$_attachments = get_posts(array('include' => $include, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby));

		$attachments = array();
		foreach ($_attachments as $key => $val) {
			$attachments[$val->ID] = $_attachments[$key];
		}
	} elseif (!empty($exclude)) {
		$exclude     = preg_replace('/[^0-9,]+/', '', $exclude);
		$attachments = get_children(array('post_parent' => $id, 'exclude' => $exclude, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby));
	} else {
		$attachments = get_children(array('post_parent' => $id, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby));
	}

	if (empty($attachments))
		return '';

	if (is_feed()) {
		$output = "\n";
		foreach ($attachments as $att_id => $attachment)
			$output .= wp_get_attachment_link($att_id, $size, true) . "\n";
		return $output;
	}


	$output = '<section class="flo-gallery-shortcode grid-view masonry-grid gallery-' . $columns . '-columns"><div class="gallery-shortcode-wrap row">';


	$i       = 0;
	$rand_id = mt_rand(1, 1000);

	$block_width = ' ' . cosmo_columns_arabic_to_chars($columns) . ' ';

	foreach ($attachments as $id => $attachment) {
		$image_attributes = wp_get_attachment_image_src($id, 'full');

		if (isset($attachment->post_excerpt) && strlen($attachment->post_excerpt)) {
			$image_caption = $attachment->post_excerpt;
		} else {
			$image_caption = '';
		}

		if (isset($attachment->post_content) && strlen($attachment->post_content)) {
			$image_description = $attachment->post_content;
		} else {
			$image_description = '';
		}

		$src = wp_get_attachment_image_src($id, 'full'); // get full attachment source
		if (isset($src[0])) {
			$src = $src[0];
		} else {
			$src = '';
		}
		$img_url = aq_resize($src, 9999, 900, $crop = false, $single = true); //resize img , height 400px

		//$link = '<a href="'.$image_attributes[0].'" data-fancybox-group="prettyPhoto['.$rand_id.']" title="'.$image_caption . $image_description.'" >'.wp_get_attachment_image($id, $size, false).'</a>';
		$link = '<div class=" post-preview gallery-shortcode flo-' . $columns . '-columns" ><a href="' . $image_attributes[0] . '"   data-fancybox-group="prettyPhoto[' . $rand_id . ']"  title="' . $image_caption . $image_description . '" ><img src="' . $img_url . '" alt="' . $attachment->post_title . '"  /></a></div>';
		$output .= $link;

	}

	$output .= "</div></section>\n";

	//enable massonry
	//    wp_localize_script('functions', 'enable_massonry', '1');
	/* include jquery.fancybox.pack*/



	return $output;
}

/**
 * Description   : this function will return the class name for the blocks depending on the input (number of columns we want to have)
 *
 *
 * @param    int $arabic - number of columns we want to have
 *
 * @return str
 *****/
if (!function_exists('cosmo_columns_arabic_to_chars')) {
	function cosmo_columns_arabic_to_chars($arabic)
	{
		$words_full_width = array(0 => 'small-12 medium-12', 1 => 'small-12 medium-12', 2 => 'small-12 medium-6', 3 => 'small-12 medium-4', 4 => 'small-12 medium-3', 5 => 'small-12 medium-3', 6 => 'small-12 medium-2',
		                          7 => 'small-12 medium-2', 8 => 'small-12 medium-12', 9 => 'small-12 medium-12', 10 => 'small-12 medium-12', 11 => 'small-12 medium-12', 12 => 'small-12 medium-12');
		return $words_full_width[$arabic];
	}
}

function cosmo_isValidURL($url)
{
	return preg_match('|^http(s)?://[a-z0-9-]+(.[a-z0-9-]+)*(:[0-9]+)?(/.*)?$|i', $url);
}

/**
 * @return array - registered social profiles
 */

function flo_get_available_social_services()
{

	$available_social_services = array();
	global $flo_options;

	if(isset($flo_options['social'])){
		$social_profiles = $flo_options['social'];

		if (sizeof($social_profiles) && is_array($social_profiles)) {
			foreach ($social_profiles as $key => $s_profile) {
				if (strlen($s_profile['title'])) {
					$available_social_services[$s_profile['title']] = $s_profile['title'];
				}
			}
		}
	}


	return $available_social_services;
}

/**
 * render social icons
 */
if (!function_exists('flo_get_social_icons')) {
	function flo_get_social_icons($enabled_services = array('facebook', 'twitter', 'gplus', 'yahoo', 'dribbble', 'linkedin', 'vimeo', 'youtube', 'tumblr', 'delicious', 'flickr', 'instagram', 'pinterest', 'skype', 'email',
			'rss'), $no_icons = false, $add_search = false)
	{

		if (!(is_array($enabled_services) && sizeof($enabled_services))) {
			$enabled_services = array();
		}

		// the following social profiles have font icons support
		$default_supported_profiles = array('facebook', 'twitter', 'gplus', 'yahoo', 'dribbble', 'linkedin', 'vimeo', 'youtube', 'tumblr', 'delicious', 'flickr', 'instagram', 'pinterest', 'skype', 'email', 'rss');
		global $flo_options;

		if(isset($flo_options['social'])){
			$social_profiles = $flo_options['social'];
		}else{
			$social_profiles = '';
		}
		
		//        $social_profiles = get_option('_social');

		ob_start();
		ob_clean();

		$social_icons_content = '';

		if (!$no_icons && sizeof($social_profiles) && is_array($social_profiles)) {


			foreach ($social_profiles as $key => $s_profile) {

				//if(isset($s_profile['title']) && in_array(  trim($s_profile['title']), $enabled_services) ){
				// backwards compatibility

				if(isset($s_profile['url']) && isset($s_profile['title'])){

					$profile_url = $s_profile['url'];
					if (in_array(trim($s_profile['title']), $enabled_services)) {
						if (isset($s_profile['icon']) && $s_profile['icon'] != '') {
							$icon_img_src = $s_profile['icon'];
						} else {
							$icon_img_src = '';
						}

						switch (trim($s_profile['title'])) {
							case 'facebook':
								// backward compatibility: if user entered just FB profile name, we will built the real URL below
								if (!cosmo_isValidURL($profile_url) && strlen($profile_url)) {
									$profile_url = 'http://facebook.com/people/@/' . $profile_url;
								}

								break;

							case 'twitter':
								// backward compatibility: if user entered just Twitter profile name, we will built the real URL below
								if (!cosmo_isValidURL($profile_url) && strlen($profile_url)) {
									$profile_url = 'http://twitter.com/' . $profile_url;
								}

								break;

						}
						$icon_class = '';
						$over_class = '';
						if (isset($s_profile['roll_over']) && $s_profile['roll_over'] != '') {
							$over_class = 'flo-social-hover';
						}
						if (!isset($s_profile['icon']) || (isset($s_profile['icon']) && trim($s_profile['icon']) == '')
								&& isset($s_profile['title']) && in_array(trim(strtolower($s_profile['title'])), $default_supported_profiles)
						) {
							$icon_class = 'porto-ico-' . trim(strtolower($s_profile['title']));
							$icon       = '';
						} else if (isset($icon_img_src) && strlen($icon_img_src) && $icon_img_src != '') {
							$icon = '<i class=" "><img src="' . $icon_img_src . '" data-imghover="' . $s_profile['roll_over'] . '" data-imgoriginal="' . $icon_img_src . '"  class="' . $over_class . '" /></i>';
						} else {
							$icon = '<span class="social-text">' . $s_profile["title"] . '</span><i class=""></i>';
						}

						if (strlen(trim($profile_url))) {
							//var_dump($icon);
							?>
							<li>
								<a href="<?php echo addhttp($profile_url) ?>" target="_blank"
								   class="<?php echo ' social-links_link icon ' . $icon_class . ' '; ?> "><?php if (isset($icon) && $icon != '') {
										echo $icon;
									} ?></a>
							</li>
						<?php
						}

					}

				}  //// EOF if isset $s_profile['url'] 

			}
		} else if(is_array($social_profiles) && sizeof($social_profiles)) {
			foreach ($social_profiles as $key => $s_profile) {

				//if(isset($s_profile['title']) && in_array(  trim($s_profile['title']), $enabled_services) ){
				// backwards compatibility

				if(isset($s_profile['url']) && isset($s_profile['title'])){
					$profile_url = $s_profile['url'];

					if (in_array(trim($s_profile['title']), $enabled_services)) {
						if (isset($s_profile['icon'])) {
							$icon_img_src = $s_profile['icon'];
						} else {
							$icon_img_src = '';
						}

						switch (trim($s_profile['title'])) {
							case 'facebook':
								// backward compatibility: if user entered just FB profile name, we will built the real URL below
								if (!cosmo_isValidURL($profile_url) && strlen($profile_url)) {
									$profile_url = 'http://facebook.com/people/@/' . $profile_url;
								}

								break;

							case 'twitter':
								// backward compatibility: if user entered just Twitter profile name, we will built the real URL below
								if (!cosmo_isValidURL($profile_url) && strlen($profile_url)) {
									$profile_url = 'http://twitter.com/' . $profile_url;
								}

								break;

						}
						$icon_class = '';
						$over_class = '';
						if (isset($s_profile['roll_over']) && $s_profile['roll_over'] != '') {
							$over_class = 'flo-social-hover';
						} else if (isset($icon_img_src) && strlen($icon_img_src)) {
							$icon = '<i class=" "><img src="' . $icon_img_src . '" data-imghover="' . $s_profile['roll_over'] . '" data-imgoriginal="' . $icon_img_src . '"  class="' . $over_class . '" /></i>';
						} else {
							$icon = '<span class="social-text">' . $s_profile["title"] . '</span><i class=""></i>';
						}

						if (strlen(trim($profile_url))) {

							?>
							<li>
								<a href="<?php echo addhttp($profile_url) ?>" target="_blank"
								   class="<?php echo ' social-links_link icon ' . $icon_class . ' '; ?> "><?php if (isset($icon)) {
										echo $icon;
									} ?></a>
							</li>
						<?php
						}

					}

				}

			}
		}

		$social_icons_content = ob_get_clean();

		if ($add_search) { // append search
			$social_icons_content .= '<a href="javascript:void(0);" class="the-header-search"> <i class="icon-search"></i> </a>';
		}
		if (strlen(trim($social_icons_content))) {
			?>
			<?php echo $social_icons_content; ?>
			<?php
			if ($add_search) { // append search
				?>
				<div class="header-serch">
					<form action="<?php echo home_url(); ?>/" method="get" id="searchform-header">
						<fieldset>
							<input class="input" name="s" type="text" id="keywords1" value="" placeholder="search">
							<button><i class="icon-search"></i></button>
							<i class="icon-close"></i>
						</fieldset>
					</form>
				</div>
			<?php
			}
		}
	}
}
if (!function_exists('flo_wpforce_featured')) {
	/* if a post does not have featured image, then we set the first attached image as feat img */
	function flo_wpforce_featured()
	{
		global $flo_options;
		if (isset($flo_options['flo-set_featured']) && $flo_options['flo-set_featured'] != '0') {
			global $post;

			$post_types_to_work_with = array('post', 'gallery'); // add more posts here if you want.

			if (isset($post->ID)) {
				$the_post_format = get_post_type($post->ID);
			} else {
				$the_post_format = 'unknown';
			}


			if (in_array($the_post_format, $post_types_to_work_with)) {
				$already_has_thumb = has_post_thumbnail($post->ID);
				if (!$already_has_thumb) {
					$attached_image = get_children("post_parent=$post->ID&post_type=attachment&post_mime_type=image&numberposts=1");
					if ($attached_image) {
						foreach ($attached_image as $attachment_id => $attachment) {
							set_post_thumbnail($post->ID, $attachment_id);
						}
					}
				}
			}

		}

	} //end function
}
add_action('the_post', 'flo_wpforce_featured');
add_action('save_post', 'flo_wpforce_featured');
add_action('draft_to_publish', 'flo_wpforce_featured');
add_action('new_to_publish', 'flo_wpforce_featured');
add_action('pending_to_publish', 'flo_wpforce_featured');
add_action('future_to_publish', 'flo_wpforce_featured');


//================= include custom meta boxes =================//

require_once dirname(__FILE__) . '/cmb_config.php';


/**
 * Load Theme Variable Data
 * @param string $var
 * @return string
 */
function theme_data_variable($var)
{
	if (!is_file(STYLESHEETPATH . '/style.css')) {
		return '';
	}

	$theme_data = wp_get_theme();
	return $theme_data->{$var};

}

function flo_add_admin_menu()
{
	if (!FLOTHEME_CUSTOMIZED) {

		add_submenu_page('_flo_options', __('Theme Updater', 'flotheme'), __('Theme Updates', 'flotheme'), 'edit_theme_options', 'flotheme_updater', 'flotheme_updater_page');
	}
}

add_action('admin_menu', 'flo_add_admin_menu', 11);


function additional_mime_types($mimes)
{
	$mimes['ico'] = 'image/x-icon';
	return $mimes;
}

add_filter('upload_mimes', 'additional_mime_types');


function tcx_customizer_live_preview()
{

	wp_enqueue_script(
			'tcx-theme-customizer',
			get_template_directory_uri() . '/js/theme-customizer.js',
			array('jquery'),
			'0.3.0',
			true
	);
	wp_enqueue_style('icons', get_template_directory_uri() . '/flo-options/ReduxCore/assets/css/vendor/elusive-icons/elusive-webfont.css');

}

add_action('customize_controls_enqueue_scripts', 'tcx_customizer_live_preview');

//    require_once get_template_directory() . "/customize-controls/spacing-control.php";

function get__posts($args = array(), $first_label = 'Select item')
{
	$posts  = get_posts($args);
	$result = array();

	if (is_array($first_label)) {
		$result = $first_label;
	} else {
		if (strlen($first_label)) {
			$result[] = $first_label;
		}
	}
	if (is_array($posts) && !empty($posts)) {
		foreach ($posts as $post) {
			$result[$post->ID] = $post->post_title;
		}
	}

	return $result;
}


/**
 * Create a nicely formatted and more specific title element text for output
 * in head of document, based on current view.
 *
 *
 * @param string $title Default title text for current view.
 * @param string $sep Optional separator.
 * @return string The filtered title.
 */
function flo_wp_title($title, $sep)
{
	global $paged, $page;

	if (is_feed()) {
		return $title;
	}

	// Add the site name.
	$title .= get_bloginfo('name');

	// Add the site description for the home/front page.
	$site_description = get_bloginfo('description', 'display');
	if ($site_description && (is_home() || is_front_page())) {
		$title = "$title $sep $site_description";
	}

	// Add a page number if necessary.
	if ($paged >= 2 || $page >= 2) {
		$title = "$title $sep " . sprintf(__('Page %s', 'flotheme'), max($paged, $page));
	}

	return $title;
}

add_filter('wp_title', 'flo_wp_title', 10, 2);



/* related posts by herarchical taxonomy */
/* get tax slugs and number of similar posts  */
function similar_query($post_id, $taxonomy, $posts_per_page = 4)
{

	$the_post_type = get_post_type($post_id);
	if ('video' == $the_post_type) {
		if ($taxonomy == 'post_tag') {
			$taxonomy = 'tag';
		}
		$taxonomy = 'video-' . $taxonomy;
	}

	$topics = wp_get_post_terms($post_id, $taxonomy);

	$terms = array();
	if (!empty($topics)) {
		foreach ($topics as $topic) {
			$term = get_term($topic->term_id, $taxonomy);
			if (isset($term->slug)) {
				array_push($terms, $term->slug);
			}

		}
	}

	if (!empty($terms)) {
		$query = new WP_Query(array(
				'post_type'           => $the_post_type,
				'post__not_in'        => array($post_id),
				'posts_per_page'      => $posts_per_page,
				'orderby'             => 'rand',
				'ignore_sticky_posts' => 1,
				'tax_query'           => array(
						array(
								'taxonomy' => $taxonomy,
								'field'    => 'slug',
								'terms'    => $terms,
						)
				)
		));
	} else {
		$query = array();
	}


	return $query;
}

/*Upload image for title decoration */
function include_custom_script_for_admin_panel()
{
	if (!did_action('wp_enqueue_media')) {
		wp_enqueue_media();
	}
	global $flo_options;
	wp_register_script( 'jquery-ui-autocomplete', '', array( 'jquery-ui-widget', 'jquery-ui-position' ), '1.8.6' ); //don't loads the autocomplete
	wp_enqueue_script( 'jquery-ui-autocomplete');
	wp_enqueue_script('myuploadscript', get_template_directory_uri() . '/js/admin.js', array('jquery'), NULL, false);

	$customizer_fields_array = array(
			'1' => 'flo-favicon',
			'2' => 'flo-logo_image_desktop',
			'3' => 'flo-logo_image_mobile'
	);
	$customizer_config = array();
	foreach($customizer_fields_array as $field){
		if(isset($flo_options) && isset($flo_options[$field]) && is_array($flo_options[$field])){
			$customizer_config[$field] = $flo_options[$field]['url'];
		}else{
			if(isset($flo_options[$field])){
				$customizer_config[$field] = $flo_options[$field];
			}

		}
	}

	wp_localize_script( 'myuploadscript', 'customizerConfig', $customizer_config); // localize visible nearby slideshow img width

}

add_action('admin_enqueue_scripts', 'include_custom_script_for_admin_panel');

function true_image_uploader_field($name, $value = '', $w = 115, $h = 90)
{
	$default = get_template_directory_uri() . '/images/no_img.png';
	if ($value) {
		$image_attributes = wp_get_attachment_image_src($value, array($w, $h));
		$src              = $image_attributes[0];
	} else {
		$src = $default;
	}

	echo '
	<div>
		<img data-src="' . $default . '" src="' . $src . '" width="' . $w . 'px" height="' . $h . 'px" />
		<div>
			<input type="hidden" name="' . $name . '" id="' . $name . '" value="' . $value . '" />
			<button type="submit" class="upload_image_button button">Upload</button>
			<button type="submit" class="remove_image_button button">&times;</button>
		</div>
	</div>
	';
}

/*
 * Добавляем метабокс
 */
function true_meta_boxes_u()
{
	$post_types = array('post', 'page');
	add_meta_box('truediv', 'Title decoration image', 'true_print_box_u', 'page', 'side');
	add_meta_box('truediv', 'Title decoration image', 'true_print_box_u', 'post', 'side');
	add_meta_box('truediv', 'Title decoration image', 'true_print_box_u', 'video', 'side');
	add_meta_box('truediv', 'Title decoration image', 'true_print_box_u', 'gallery', 'side');
}

add_action('admin_menu', 'true_meta_boxes_u');

/*
 * Заполняем метабокс
 */
function true_print_box_u($post)
{
	if (function_exists('true_image_uploader_field')) {
		true_image_uploader_field('uploader_custom', get_post_meta($post->ID, 'uploader_custom', true));
	}
}

/*
 * Сохраняем данные произвольного поля
 */
function true_save_box_data_u($post_id)
{
	if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
		return $post_id;
	if (isset($_POST['uploader_custom'])) {
		update_post_meta($post_id, 'uploader_custom', $_POST['uploader_custom']);
	}
	return $post_id;
}

add_action('save_post', 'true_save_box_data_u');

function true_add_options_page_u()
{
	if (isset($_GET['page']) == 'uplsettings') {
		if ('save' == isset($_REQUEST['action'])) {
			if (isset($_REQUEST['uploader_custom'])) {
				update_option('uploader_custom', $_REQUEST['uploader_custom']);
				header("Location: " . site_url() . "/wp-admin/options-general.php?page=uplsettings&saved=true");
				die;
			}
		}
	}
	//		add_submenu_page('options-general.php','Дополнительные настройки','Настройки','edit_posts', 'uplsettings', 'true_print_options_u');
}

function true_print_options_u()
{
	if (isset($_REQUEST['saved'])) {
		echo '<div class="updated"><p>Saved.</p></div>';
	}
	?>
	<div class="wrap">
	<form method="post">
		<?php
		if (function_exists('true_image_uploader_field')) {
			true_image_uploader_field('uploader_custom', get_option('uploader_custom'));
		}
		?><p class="submit">
			<input name="save" type="submit" class="button-primary" value="Save changes"/>
			<input type="hidden" name="action" value="save"/>
		</p>
	</form>

	</div><?php
}

add_action('admin_menu', 'true_add_options_page_u');

/* START : Code for register two new metaboxes in the admin panel for all post types*/


add_action('save_post', '_save_post');
add_action('admin_head', '_add_admin_styles');
add_action('edit_form_after_title', '_add_after_field');

function _add_subtitle_meta_box()
{
	global $post;
	if ($post->post_type == 'page' || $post->post_type == 'video' || $post->post_type == 'gallery' || $post->post_type == 'post') {
		echo '<input type="hidden" name="wps_noncename" id="wps_noncename" value="' . wp_create_nonce('wp-subtitle') . '" />';
		echo '<input type="text" id="wpsubtitle" name="wps_subtitle" value="" style="width:99%;" />';
		//	echo apply_filters( 'wps_subtitle_field_description', '', $post );
	}
}

function _add_after_field()
{
	global $post;
	if ($post->post_type == 'page') {
		echo '<div id="subtitlediv" class="top with_bottom_margin" style="line-height: 32px;">';
		echo '<div id="subtitlewrap">';
		echo '<input type="text" id="wpsubtitle" name="wps_after" value="' . get_post_meta($post->ID, 'wps_after', true) . '" autocomplete="off" />';
		echo '<div class="subtitledescription">' . __('This text is after the title. ( Optional field )', 'flotheme') . '</div>';
		echo '</div>';
		echo '</div>';
		echo '<div class="clear"></div>';
	}
}

function _save_post($post_id)
{
	if (isset($_POST['wps_after'])) {
		update_post_meta($post_id, 'wps_after', $_POST['wps_after']);
	}
}

function _add_admin_styles()
{
	?>
	<style>
		#subtitlediv.top
		{
			top: 5px;
			position: relative;
		}

		#subtitlediv.top #subtitlewrap
		{
			border: 0;
			padding: 0;
		}

		.with_bottom_margin
		{
			bottom: 5px;
		}

		#subtitlediv.top #wpsubtitle
		{
			background-color: #fff;
			font-size: 1.4em;
			line-height: 1em;
			margin: 0;
			outline: 0;
			padding: 3px 8px;
			width: 50%;
			height: 1.7em;
			float: left;
		}

		#subtitlediv.top #wpsubtitle::-webkit-input-placeholder
		{
			padding-top: 3px;
		}

		#subtitlediv.top #wpsubtitle:-moz-placeholder
		{
			padding-top: 3px;
		}

		#subtitlediv.top #wpsubtitle::-moz-placeholder
		{
			padding-top: 3px;
		}

		#subtitlediv.top #wpsubtitle:-ms-input-placeholder
		{
			padding-top: 3px;
		}

		#subtitlediv.top .subtitledescription
		{
			margin: 5px 10px 0 10px;
			float: left;
		}
	</style>
<?php
}

function flo_title($post_id)
{
	$new_title = '';
		$title = get_the_title($post_id);
		$after = get_post_meta($post_id, 'wps_after', true);
		$new_title .= $title;
		if ($after) {
			$new_title .= ' <h4 class="sub-title">' . $after . '</h4>';
		}
	return $new_title;
}

/* END : This is the function for show (if exist )custom titles by Sliva */
if (!function_exists('hex2rgb')) {
	function hex2rgb($hex)
	{
		$hex = str_replace("#", "", $hex);

		if (strlen($hex) == 3) {
			$r = hexdec(substr($hex, 0, 1) . substr($hex, 0, 1));
			$g = hexdec(substr($hex, 1, 1) . substr($hex, 1, 1));
			$b = hexdec(substr($hex, 2, 1) . substr($hex, 2, 1));
		} else {
			$r = hexdec(substr($hex, 0, 2));
			$g = hexdec(substr($hex, 2, 2));
			$b = hexdec(substr($hex, 4, 2));
		}
		//$rgb = array($r, $g, $b);
		$rgb = $r . ',' . $g . ',' . $b . ', ';

		//return implode(",", $rgb); // returns the rgb values separated by commas
		return $rgb; // returns an array with the rgb values
	}
}

/**
 * Check if we are on a page and if the page has a slider assigned.
 * If all that is trye, then return an array with the selected slider options
 *
 *
 * @return array containing the selected slider options
 */
if (!function_exists('flo_get_page_slyder_info')) {
	function flo_get_page_slyder_info()
	{
		global $post;

		$response = array('selected_slider_id' => 0,
		                  'slideshow_type'     => 'content_width',
		                  'menu_position'      => 'crowd-header-bottom',
		                  'logo_position'      => 'middle-center'
		);
		if (is_page()) {
			$slideshow_settings = meta::get_meta($post->ID, 'slideshowSettings');
			if (isset($slideshow_settings['slideshow_select']) && $slideshow_settings['slideshow_select'] != 0) {
				$response['selected_slider_id'] = $slideshow_settings['slideshow_select'];

				if (isset($slideshow_settings['slideshow_type'])) {
					$response['slideshow_type'] = $slideshow_settings['slideshow_type'];
				}
				if (isset($slideshow_settings['menu_position'])) {
					$response['menu_position'] = $slideshow_settings['menu_position'];
				}
				if (isset($slideshow_settings['logo_position'])) {
					$response['logo_position'] = $slideshow_settings['logo_position'];
				}
			}

		}

		return $response;
	}
}


if (!function_exists('flo_get_slideshow')) {
	function flo_get_slideshow($slideshow_id)
	{
		global $slideshow;
		$slideshow = meta::get_meta($slideshow_id, '_floslideshow');

		if (!(isset($slideshow) && is_array($slideshow) && count($slideshow))) {
			return;
		}

		if (!empty($slideshow) && is_array($slideshow)) {

			$page_slyder_info = flo_get_page_slyder_info();

			if (isset($page_slyder_info['slideshow_type']) && $page_slyder_info['slideshow_type'] != 'content_width') {
				$slider_type = 'full_width'; // will use full-width.php slidehow template
			} else {
				$slider_type = 'content_width';
			}

			// use Royal slider
			get_template_part('/parts/slideshow/' . $slider_type);


		}
	}
}

function menu($id, $args = array())
{
	$menu = new menu($args);

	$vargs = array(
			'menu'                => '',
			'container'           => '',
			'container_class'     => '',
			'container_id'        => '',
			'menu_class'          => isset($args['class']) ? $args['class'] : '',
			'menu_id'             => '',
			'echo'                => false,
			'fallback_cb'         => 'flo_page_menu',
			'before'              => '',
			'after'               => '',
			'link_before'         => '',
			'link_after'          => '',
			'depth'               => 0,
			'walker'              => $menu,
			'theme_location'      => $id,
			'nr_items_per_column' => isset($args['nr_items_per_column']) ? $args['nr_items_per_column'] : 9999, /// if you don't want to have several columns in menu, set 9999
	);

	$result = wp_nav_menu($vargs);


	if ($menu->need_more && $id != 'megusta') {
		$result .= "</li></ul>" . $menu->aftersubm;
	}

	return $result;
}

/**
 * adds the logo to the menu object
 *
 * @params:
 * $items - string, the menu items in html format
 * $args - array, menu config arguments
 * @return - string, the modified menu with them logo in the middle
 */
if (!function_exists('flo_add_menu_to_nav')) {
	function flo_add_menu_to_nav($items, $args)
	{

		if (is_object($args->walker)) {
			$number_menu_items = $args->walker->count;

			// now we need to find the index of the menu item where the LOGO will be inserted. i.e. if the menu has 6 menu items, then the logo will be inserted after the 3rd elem.
			$before_logo_index = round($number_menu_items / 2);


			if (!class_exists('simple_html_dom_node')) { // make sure we will not have conflicts with other plugins that are using simple_html_dom class
				require('simple_html_dom.php');
			}

			// now we will parse the menu items dom using simple_html_dom library
			$html = new simple_html_dom();
			$html->load('<ul class="temp-wrapper">' . $items . '</ul>');


			$menu_items = $html->find('.temp-wrapper', 0)->children(); // get just the top level menu items

			$new_menu = ''; // init and empty menu that will be built from the old menu + the logo
			foreach ($menu_items as $key => $value) {
				$original_class = $value->class;


				// update the class
				if ($key < $before_logo_index) {
					$value->class = $original_class . ' left-logo-menu ';
				} else {
					$value->class = $original_class . ' right-logo-menu ';
				}

				$new_menu .= $value->outertext;
				// if we are in the middle of the menu, add the logo
				if ($before_logo_index == $key + 1) {

					$the_logo = flo_get_logo();

					$new_menu .= '<li class="menu-item logo-inside site-logo">' . $the_logo . '</li>';
				}

			}

			return $new_menu;

		} else {
			return $items;
		}

	}
}

/*
	process the ajax request that sends the distance between header 4 menu elements
	Updates the options with the received data
	*/
function flo_header_logo_center_menu_items_margin()
{
	if (isset($_POST['header_logo_center_menu_spacing_nonce']) && isset($_POST['left_spacing']) && strlen($_POST['left_spacing']) && isset($_POST['right_spacing']) && strlen($_POST['right_spacing'])) {
		// check to see if the submitted nonce matches with the
		// generated nonce we created earlier
		if (!wp_verify_nonce($_POST['header_logo_center_menu_spacing_nonce'], 'header_logo_center_menu_spacing_nonce_val')) {
			die ('Busted! Wrong Nonce');
		}

		// update the options with the value we recived
		update_option('header_logo_center_menu_left_spacing', ($_POST['left_spacing']));
		update_option('header_logo_center_menu_right_spacing', ($_POST['right_spacing']));

		echo get_option('header_logo_center_menu_left_spacing', true) . ' & ' . get_option('header_logo_center_menu_right_spacing', true);

	}

	exit();
}

if (!has_action('flo_footer_credits')) {
	add_action('flo_footer_credits', 'flo_get_footer_credits', 10);
}

if (!function_exists('flo_get_footer_credits')) {
	function flo_get_footer_credits()
	{
		echo sprintf(__(' %s Made By Flothemes %s', 'flotheme'), '<a href="http://flothemes.com/"  target="blank" class="flo-logo porto-ico porto-ico-flo">', '</a>');
	}

}
if (!function_exists('cosmo_get_custom_css')) {
	function cosmo_get_custom_css(){
		global $flo_options,$post;

		// set the distance between Header 4 menu items such that the menu
		// will use the whole content width
		$header_4_menu_left_spacing  = get_option('header_logo_center_menu_left_spacing', '0px');
		$header_4_menu_right_spacing = get_option('header_logo_center_menu_right_spacing', '0px');
		$site_width                  = 1200;
		$max_logo_mobile_width = $flo_options['flo-max_logo_mobile_width'];
		$max_logo_desctop_width = $flo_options['flo-max_logo_width'];

		if(isset($post->ID)){
			$remove_padding  = get_post_meta($post->ID,'settings');
		}

		if($flo_options['flo-enable_clickable_grid_views'] == '0'){
			$clickable_grid_views_class = 'display:none';;

		} else {
			$clickable_grid_views_class = null;
		}

		?>
				
		<style type="text/css">

			<?php
			if(isset($clickable_grid_views_class)):?>
				.block .grid-full-permalink{
					<?php echo $clickable_grid_views_class;?>
				}
			<?php endif;?>
			<?php

			if(isset($remove_padding) && $remove_padding != null && is_array($remove_padding) && isset($remove_padding[0]['remove_page_bg_padding']) && $remove_padding[0]['remove_page_bg_padding'] == 'no'){?>
			.single-page.content-full-width .page-content > .inner{
				padding: 0;
				background: none;
			}
			<?php }

			if($max_logo_desctop_width && $max_logo_desctop_width != ''){?>
			.logo-image img{
				max-width: <?php echo $max_logo_desctop_width;?>px;
			}
			<?php }
			if($max_logo_mobile_width && $max_logo_mobile_width != ''){?>
				@media only screen and (max-width: 40em) {
					.logo-image img{
						max-width: <?php echo $max_logo_mobile_width;?>px;
					}
				}
			<?php }
			?>
			@media only screen and (min-width: <?php echo $site_width; ?>px)
			{

			<?php if('0px' != $header_4_menu_right_spacing){ ?>
				.logo_center .header_main-nav ul.header_main-nav_link li.left-logo-menu
				{
					margin-right: <?php echo $header_4_menu_right_spacing; ?>;
				}

			<?php } ?>

			<?php if('0px' != $header_4_menu_left_spacing){ ?>
				.logo_center .header_main-nav ul.header_main-nav_link li.right-logo-menu
				{
					margin-left: <?php echo $header_4_menu_left_spacing; ?>;
				}

			<?php } ?>
			}

			@media only screen and (min-width: 641px) and (max-width: <?php echo $site_width; ?>px)
			{
				.logo_center .header_main-nav ul
				{
					text-align: center;
				}

				.logo_center .header_main-nav li
				{
					margin-right: 40px;
					margin-left: 0px;
				}
			}

			<?php if (isset($flo_options['flo-content_width']) && is_numeric($flo_options['flo-content_width'])): ?>
				.row{ max-width: <?php echo $flo_options['flo-content_width'] ?>px; }
			<?php endif ?>

			<?php
				echo $flo_options['flo-custom_css'];
			?>
		</style>
	<?php
	}
}

/**
 * Cosmo loop
 */
if (!function_exists('cosmo_loop')) {
	function cosmo_loop($template, $column_class = 'nine columns', $side = '')
	{
		global $wp_query, $massonry_class, $flo_options, $post, $i, $gutter, $last,$counter;

		$enable_massonry = false;

		if ($template == 'video-category-archive' || $template == 'gallery-category-archive') {
			$view_type = 'thumb';

			//global $post, $number_columns, $massonry_class, $column_class, $crop_the_thumb, $thumb_size;
			global $number_columns;
			$number_columns = 3;
			$column_class   = ' twelve columns ';
			$template       = 'archive';
			$gutter_class   = 'has-gutter';

		} else if ($template == 'blog_page') {
			$view_type = $flo_options['flo-blog_listing_layout'];
		} else {
			$view_type = $flo_options['flo-archive_listing_layout'];
		}
		$content_width_class = tools::primary_class(0, 'blog_posts', $return_just_class = true);
		if (count($wp_query->posts) > 0) {

			?>
			<div class="row ">
				<div class="columns <?php echo $content_width_class; ?>">
					<?php
					$nr_of_columns = '4';
					$nr_of_columns_featured = '3';
					$nr_of_columns_grid_50_50 = '2';
					$nr_nr_of_columns_grid_title_below = '3';
					$big_feat_post = flo_get_col_featured_big($nr_of_columns_featured);
					$nr_of_posts = '10';
					$masonry = 'yes';
					$post_type_c = 'post';
					$featured_post_id = '1';
					$gutter = 'gutter-default';

					if (isset($post_type_c) && $post_type_c != '' && $post_type_c != NULL) {
						$post_type = $post_type_c;
					} else {
						$post_type = 'post';
					}
					$enable_pagination = 'yes';
					if (isset($enable_pagination) && $enable_pagination == 'yes') {
						$pag = 'true';
					} else {
						$pag = 'false';
					}
					$view_type_class = flo_view_type_classes($view_type);
					if (isset($masonry) && $masonry == 'yes') {
						$masonry_class = 'masonry-grid';
					} else {
						$masonry_class = ' ';
					}
					if ($view_type == 'grid_mosaic' || $view_type == 'list_view_50_50' || $view_type == 'grid_pattern') {
						$gutter = '';
					}
					?>

					<div class="block <?php echo $view_type_class . ' gutter-' . $gutter . ' ' . $masonry_class; ?>">
						<div class="row">
							<?php
							if (get_query_var('paged')) {
								$current = get_query_var('paged');
							} elseif (get_query_var('page')) {
								$current = get_query_var('page');
							} else {
								$current = 1;
							}
							$query_args = array(
									'post_type'           => $post_type,
									'paged'               => $current,
									"posts_per_page"      => $nr_of_posts,
									'ignore_sticky_posts' => 1,
							);

							$the_query = new WP_Query($query_args);
							$post_ids = array();
							$i = $counter = 1;
							$size_of_array = count($the_query->posts);
							?>


							<?php if ($view_type == 'grid_view_featured_post'): ?>

								<?php
								$category_feat = wp_get_post_terms($featured_post_id, 'category');

								if ($category_feat) {
									$cat_name_feat = $category_feat[0]->name;
									$cat_link_feat = get_category_link($category_feat[0]);
								} else {
									$cat_link_feat = '';
									$cat_name_feat = '';
								}

								if (!isset($featured_post_id) || $featured_post_id == NULL) {
									$featured_post_id = '1';
								}

								if (has_post_thumbnail($featured_post_id) && !post_password_required()) {
									$feat_img_url1 = wp_get_attachment_url(get_post_thumbnail_id($featured_post_id), 'full'); //get img URL
									$feat_img_url  = aq_resize($feat_img_url1, '700', '699', true, true); //crop img
								}


								if (!isset($feat_img_url) || $feat_img_url == '') {
									$feat_img_url = get_template_directory_uri() . '/images/aq_resize/noimage.jpg';

//									$feat_img_url = aq_resize($feat_img_url1, '700', '699', true, true); //crop img
								}

								global $big_feat_post,$feat_img_url,$cat_link_feat, $cat_name_feat,$featured_post_id;
								echo get_template_part('parts/featured_image_block');
								echo get_template_part('floshortcodes/' . $view_type); ?>

							<?php endif; ?>

							<?php while ($the_query->have_posts()): $the_query->the_post(); ?>
								<?php

								if ($counter == $size_of_array) {
									$last = true;
								} else {
									$last = false;
								}
								$counter++;
								if ($view_type) {
									echo get_template_part('floshortcodes/' . $view_type);
								}
								$i++;
								$post_ids[] = $the_query->post->ID;
								?>
							<?php endwhile;
							wp_reset_postdata(); ?>
						</div>
					</div>
				</div>

<?php
layout::side('right', 0, 'blog_posts');
layout::side('left', 0, 'blog_posts');
?>
			</div>
			<?php            wp_reset_postdata(); /* Restore original Post Data */
		} else {
			get_template_part('loop', '404');
		}
	}



}
/**
 * cosmo_get_post_types_hc
 */
if (!function_exists('cosmo_get_post_types_hc')) {
	/**
	 * Description   : this function will return an array of registered custom post types
	 *
	 * @return array
	 *****/
	function cosmo_get_post_types_hc()
	{
		//of course it can be done via get_post_types, but for some reason it return only posts and pages, and no custom posts, and we have to hardcode this shit


		return array('post'    => __('Post', 'flotheme'), /*'video' => __('Video', 'flotheme'),*/
		             'gallery' => __('Gallery', 'flotheme'));
	}
}

if (!function_exists('cosmoSendContact')) {
	function cosmoSendContact()
	{
		if (isset($_POST['action']) && $_POST['action'] == 'cosmoSendContact') {
			$result = array();

			$tomail   = $_POST['cosmo-contact-email'];
			$frommail = '';

			if (isset($_POST['cosmo-name']) && strlen($_POST['cosmo-name'])) {
				$name = trim($_POST['cosmo-name']);
			} else {
				$result['contact_name'] = '<p class="text-error">' . __('Error, name is required field. ', 'flotheme') . '</p>';
				$name                   = '';
			}

			if (isset($_POST['cosmo-email']) && is_email($_POST['cosmo-email'])) {
				$frommail = trim($_POST['cosmo-email']);
			} else {

				$result['contact_email'] = '<p class="text-error">' . __('Error, please enter a valid email address. ', 'flotheme') . '</p>';

			}

			$message = '';
			if (isset($_POST['cosmo-name'])) {
				$message .= __('Contact name: ', 'flotheme') . trim($_POST['cosmo-name']) . "\n";
			}
			if (isset($_POST['cosmo-email'])) {
				$message .= __('Contact email: ', 'flotheme') . trim($_POST['cosmo-email']) . "\n";
			}
			if (isset($_POST['cosmo-subject'])) {
				$message .= __('Subject: ', 'flotheme') . trim($_POST['cosmo-subject']) . "\n\n";
			}
			$message .= trim($_POST['cosmo-message']);

			if (is_email($tomail) && strlen($tomail) && strlen($frommail) && strlen($name) && strlen($message)) {

				//flo-contact_email_address
				global $flo_options;


				// if this option is enabled, then we will use the visitor email in the Form field
                if( $flo_options['flo-contact_email_address'] ){

                	$headers = array();

					$headers[] = 'From: ' . trim($_POST['cosmo-name']) . ' <' . trim($_POST['cosmo-email']). '>';


					$headers[] = 'Reply-To: ' . trim($_POST['cosmo-email']);


                    //$headers = 'From: ' . trim($_POST['cosmo-name']) . ' <' . trim($_POST['cosmo-email']) . '>';
                }else{
                	$headers = array();

					$headers[] = 'Reply-To: ' . trim($_POST['cosmo-email']);

                    //$headers = 'Reply-To: '.trim($_POST['cosmo-name']) . ' ' . trim($_POST['cosmo-email']) .' \r\n';
                }


				$subject = __('New email from', 'flotheme') . ' ' . get_bloginfo('name') . '.' . __(' Sent via contact form.', 'flotheme');
				wp_mail($tomail, $subject, $message, $headers);

				if (isset($_POST['thx_msg']) && strlen(trim($_POST['thx_msg']))) {
					$thx_msg = urldecode($_POST['thx_msg']);
				} else {
					$thx_msg = __('Email was sent successfully ', 'flotheme');
				}

				$result['message'] = '<span class="text-success" >' . $thx_msg . '</span>';

			}

			echo json_encode($result);
		}


		exit();
	}
}

// add the link to the documentation in the WP dashboard
function flo_dashboard_documentation() {
    return array("<li class='flo-docs' ><a href='https://flothemes.zendesk.com/hc/en-us' target='_blank' ><img src='".get_template_directory_uri()."/images/documentation_img.jpg' /></a></li>");
}
add_filter( 'dashboard_glance_items', 'flo_dashboard_documentation' );

// remove 'hentry' class 
function flo_remove_hentry( $classes ) {
    global $post;
    //var_dump(in_array(get_post_type( $post ), array('video','gallery')));

    $classes = array_diff( $classes, array( 'hentry' ) );

    return $classes;
}
add_filter( 'post_class','flo_remove_hentry' );

add_filter( 'post_row_actions', 'remove_slideshow_view_link', 10, 2 );
function remove_slideshow_view_link( $action ,$post) {
	//check for your post type
	if ($post->post_type =="slideshow"){
		/*do you stuff here
		you can unset to remove actions
		and to add actions ex:
		$actions['in_google'] = '<a href="http://www.google.com/?q='.get_permalink($post->ID).'">check if indexed</a>';
		*/
		unset ($action['view']);
	}
	return $action;
}


function remove_view_button_on_single_slideshow($button){
	global $post;
	if($post->post_type == 'slideshow'){
		return preg_replace("/<span id='view-post-btn'>(.*)<\/span>/",'',$button);
	}else{
		return $button;
	}

}
add_filter('get_sample_permalink_html','remove_view_button_on_single_slideshow');


if (!function_exists('flo_get_taxonomy_array')) {
	function flo_get_taxonomy_array($tax){

		/* latest Videos template settings  */
	    $the_taxonomies = get_terms($tax, array());


	    $the_taxonomies_array = array();
	    //deb::e($video_categories);
	    foreach ($the_taxonomies as $type) {
	        $the_taxonomies_array[$type->term_id] = $type->name;
	    }
// echo '<pre>';
// var_dump($the_taxonomies_array);
// echo '</pre>';
	    return $the_taxonomies_array;
	}
}
?>
