<?php

class widget_flo_popular extends WP_Widget
{

	function widget_flo_popular()
	{
		$widget_ops = array('classname' => 'flo_popular', 'description' => __('Flo Block Posts', 'flotheme'));
		$this->WP_Widget('widget_cosmo_flo_popular', _TN_ . ' : ' . __('Flo Block Posts', 'flotheme'), $widget_ops);
	}

	function widget($args, $instance)
	{
		/* prints the widget*/
		extract($args, EXTR_SKIP);

		if (isset($instance['post_in'])) {
			$post_in = $instance['post_in'];
		} else {
			$post_in = '';
		}
		if (isset($instance['post_type'])) {
			$post_type = $instance['post_type'];
		} else {
			$post_type = '';
		}
		if (isset($instance['sub_title'])) {
			$sub_title = $instance['sub_title'];
		} else {
			$sub_title = '';
		}
		if (isset($instance['title'])) {
			$title = $instance['title'];
		} else {
			$title = 'Sample title';
		}
		if (isset($instance['link'])) {
			$link = $instance['link'];
		} else {
			$link = '';
		}
		if (isset($instance['number_posts'])) {
			$number_posts = $instance['number_posts'];
		} else {
			$number_posts = 6;
		}
		if (isset($instance['number_columns'])) {
			$number_columns = $instance['number_columns'];
		} else {
			$number_columns = 3;
		}
		if (isset($instance['gutter'])) {
			$gutter = $instance['gutter'];
		} else {
			$gutter = 'default';
		}

		if (isset($instance['background'])) {
			$background = $instance['background'];
		} else {
			$background = '';
		}
		if (isset($instance['padding'])) {
			$padding = $instance['padding'];
		} else {
			$padding = '';
		}
		if($number_columns != ''){
			if($number_columns == '2'){
				$cur_title_col = 'medium-4';
				$cur_num_col = "medium-8";
				$cur_item_num_col = "medium-6";
			}elseif($number_columns == '3'){
				$cur_title_col = 'medium-4';
				$cur_num_col = "medium-8";
				$cur_item_num_col = "medium-4";
			}elseif($number_columns == '4'){
				$cur_title_col = 'medium-3';
				$cur_num_col = "medium-9";
				$cur_item_num_col = "medium-3";
			}
		}

		$query_args = array( 'post_type' => $post_type, 'orderby' => 'title','order' => 'DESC', 'posts_per_page' => $number_posts, 'ignore_sticky_posts' => 1);
		if(isset($post_in) && is_array($post_in) ){
			//post__in
			


				$query_args['post__in'] = $post_in;


			$query_args['tax_query'] = '';
			// reset the order by
			$query_args['orderby'] = 'post__in';


		}

		if(strlen($gutter)){
			$gutter_class = 'gutter-gutter-'.$gutter;
		}else{
			$gutter_class = '';
		}

		$query = new WP_Query( $query_args );
			if(isset($background) && $background != ''):?>
				<div style="background: <?php echo $background;?>; padding:<?php echo $padding;?>px">
			<?php endif;?>
		<div class="block grid-with-title <?php echo $gutter_class; ?> ">
			<div class="row">
				<div class="columns <?php echo $cur_title_col;?>">
					<div class="title-part description short-description">
						<div class="inner">
							<?php if($sub_title != ''){?><h4 class="before-title"><?php echo $sub_title;?></h4><?php }?>
							<?php if($title != ''){?><h3 class="title"><?php echo $title;?></h3><a href="<?php echo $link;?>" class="btn">View All</a> </div><?php }?>
					</div>
				</div>
				<div class="columns <?php echo $cur_num_col;?>">
					<div class="row">
						<div class="grid-part">
							<?php
							foreach($query->posts as $item){
								?>
								<div class="item columns <?php echo $cur_item_num_col;?>">

									<?php

									if (has_post_thumbnail($item->ID) && !post_password_required()) {
										$img_url1 = wp_get_attachment_url(get_post_thumbnail_id($item->ID), 'full'); //get img URL
										$img_url = aq_resize($img_url1, 600, 600, true, true); //crop img
									}

									if (!isset($img_url) || $img_url == '') {
										$img_url = get_template_directory_uri().'/images/aq_resize/noimage.jpg';
//										$img_url  = aq_resize($img_url1, 200, 200, true, true, true, 'noimage.jpg');
									}?>
									<figure><img src="<?php echo $img_url;?>" alt="">
										<div class="figure-hover">
											<div class="inner"><a href="<?php echo get_the_permalink($item->ID)?>" class="title"><?php echo $item->post_title;?></a></div>
										</div>
									</figure>
								</div>
							<?php
							}
							?>
						</div>
					</div>
				</div>
			</div>
		</div>
			<?php if(isset($background) && $background != ''):?>
				</div>
			<?php endif;?>
			<?php

	}

	function update($new_instance, $old_instance)
	{
		/*save the widget*/
		$instance = $old_instance;

		$instance['post_type']           = strip_tags($new_instance['post_type']);
		$instance['sub_title']           = strip_tags($new_instance['sub_title']);
		$instance['title']           = strip_tags($new_instance['title']);
		$instance['link']           = strip_tags($new_instance['link']);
		$instance['background']           = strip_tags($new_instance['background']);
		$instance['padding']           = strip_tags($new_instance['padding']);
		$instance['number_posts']           = strip_tags($new_instance['number_posts']);
		$instance['number_columns']           = strip_tags($new_instance['number_columns']);
		$instance['gutter']           = strip_tags($new_instance['gutter']);

		$instance['post_in'] = array();

        if ( isset ( $new_instance['post_in'] ) && is_array($new_instance['post_in']) )
        {
            foreach ( $new_instance['post_in'] as $value )
            {
                if ( '' !== trim( $value ) )
                    $instance['post_in'][] = $value;
            }
        }




		return $instance;
	}

	function form($instance)
	{
		/* widget form in backend */
		$instance = wp_parse_args((array)$instance, array('post_in' => array(), 'post_type' => '','background' => '', 'padding' => '', 'number_posts' => '6', 'number_columns' => '3','gutter'=>'','sub_title'=>'The pretitle','link'=>'','title'=>'The title'));

		$post_type           = strip_tags($instance['post_type']);
		$post_in           = $instance['post_in'];
		$sub_title           = strip_tags($instance['sub_title']);
		$title           = strip_tags($instance['title']);
		$background           = strip_tags($instance['background']);
		$padding           = strip_tags($instance['padding']);
		$link           = strip_tags($instance['link']);
		$number_posts           = strip_tags($instance['number_posts']);
		$number_columns           = strip_tags($instance['number_columns']);
		$gutter           = strip_tags($instance['gutter']);
		wp_enqueue_media(); // need this for the image uploader


		$selected_posts = '';
		if(isset($post_in) && is_array($post_in) && sizeof($post_in)){
			// showing the selected posts

			$the_query = new WP_Query( array( 'post_type' => 'any', 'ignore_sticky_posts' => 1, 'post__in' => array_values($post_in) ) );

			$selected_posts .= '<span class="lable"><b>'.__('Selected Posts:','flotheme').'</b></span> ';
			while ( $the_query->have_posts() ){
				$the_query->the_post();

				$selected_posts .= '<span><input type="hidden" name="'.$this->get_field_name('post_in').'[]" value="'.$the_query->post->ID.'"><a id="post_tag-check-num-0" class="ntdelbutton" tabindex="0">X</a>&nbsp;'.$the_query->post->post_title.'</span>';
			}

		}


		?>
		<p>
			<label for="<?php echo $this->get_field_id('post_type'); ?>"><?php _e('Post Type', 'flotheme') ?>:
				<select class="widefat" id="<?php echo $this->get_field_id('post_type'); ?>" name="<?php echo $this->get_field_name('post_type'); ?>">
					<option value="post" <?php  if(esc_attr($post_type) == 'post'){echo "selected='selected'";}?>>Post</option>
					<option value="gallery" <?php  if(esc_attr($post_type) == 'gallery'){echo "selected='selected'";}?>>Gallery</option>
				</select>
			</label>
		</p>
	
		<p>
			<label for="<?php echo $this->get_field_id('background'); ?>"><?php _e('Background color (hex)', 'flotheme') ?>:</br>
				<input class="widefat text_color_picker_c" id="<?php echo $this->get_field_id('background'); ?>" name="<?php echo $this->get_field_name('background'); ?>"  type="text" value="<?php echo $background; ?>"/>
			</label>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id('padding'); ?>"><?php _e('Background Padding', 'flotheme') ?>:</br><?php _e('<span style="color:blue">Add padding for widget (in px)</span>', 'flotheme') ?>
				<input class="widefat" id="<?php echo $this->get_field_id('padding'); ?>" name="<?php echo $this->get_field_name('padding'); ?>"  type="text" value="<?php echo $padding; ?>"/>
			</label>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id('post_in'); ?>"><?php _e('Select the feature Posts', 'flotheme') ?>:
				<br/><span class="hint"><?php _e('begin typing the post name','flothme') ?></span>
				<input class="widefat " onkeypress="search_multiple_posts(jQuery(this),'<?php echo $this->get_field_name('post_in'); ?>')" data-post_type="any"   type="text" value=""/>
				
				<div class="multi-search-result tagchecklist"><?php echo $selected_posts; ?></div>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title', 'flotheme') ?>:
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>"  type="text" value="<?php echo $title; ?>"/>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('sub_title'); ?>"><?php _e('Before Title', 'flotheme') ?>:
				<input class="widefat" id="<?php echo $this->get_field_id('sub_title'); ?>" name="<?php echo $this->get_field_name('sub_title'); ?>"  type="text" value="<?php echo $sub_title; ?>"/>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('link'); ?>"><?php _e('Link', 'flotheme') ?>:
				<input class="widefat" id="<?php echo $this->get_field_id('link'); ?>" name="<?php echo $this->get_field_name('link'); ?>"  type="text" value="<?php echo $link; ?>"/>
			</label>
		</p>
		<p class="number_columns">
			<label for="<?php echo $this->get_field_id('number_columns'); ?>"><?php _e('Number of columns', 'flotheme') ?>:
				<select class="widefat" id="<?php echo $this->get_field_id('number_columns'); ?>" name="<?php echo $this->get_field_name('number_columns'); ?>">
					<option value="2" <?php  if(esc_attr($number_columns) == '2'){echo "selected='selected'";}?>>2</option>
					<option value="3" <?php  if(esc_attr($number_columns) == '3' || !$number_columns ){echo "selected='selected'";}?>>3</option>
					<option value="4" <?php  if(esc_attr($number_columns) == '4'){echo "selected='selected'";}?>>4</option>
				</select>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('number_columns'); ?>"><?php _e('Number of posts', 'flotheme') ?>:
				<input class="widefat" id="<?php echo $this->get_field_id('number_posts'); ?>" name="<?php echo $this->get_field_name('number_posts'); ?>"  type="text" value="<?php if(!$number_posts){echo "6";}else{echo $number_posts;}?>"/>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('gutter'); ?>"><?php _e('Gutter', 'flotheme') ?>:
				<select class="widefat" id="<?php echo $this->get_field_id('gutter'); ?>" name="<?php echo $this->get_field_name('gutter'); ?>">
					<option value="default" <?php  if(esc_attr($gutter) == 'default'){echo "selected='selected'";}?>>Default 30px</option>
					<option value="0" <?php  if(esc_attr($gutter) == '0'){echo "selected='selected'";}?>>No gutter</option>
					<option value="2" <?php  if(esc_attr($gutter) == '2'){echo "selected='selected'";}?>>Gutter 2px</option>
					<option value="5" <?php  if(esc_attr($gutter) == '5'){echo "selected='selected'";}?>>Gutter 5px</option>
					<option value="10" <?php  if(esc_attr($gutter) == '10'){echo "selected='selected'";}?>>Gutter 10px</option>
					<option value="20" <?php  if(esc_attr($gutter) == '20'){echo "selected='selected'";}?>>Gutter 20px</option>
					<option value="40" <?php  if(esc_attr($gutter) == '40'){echo "selected='selected'";}?>>Gutter 40px</option>
					<option value="50" <?php  if(esc_attr($gutter) == '50'){echo "selected='selected'";}?>>Gutter 50px</option>
				</select>
			</label>
		</p>

		<script type="text/javascript">
			var str = "";
			jQuery( ".view_type" ).trigger( "change" ).change(function() {
				jQuery( ".view_type option:selected" ).each(function() {
					str = jQuery( this ).val();
					if(str == 'thumb_view_title_over'){
						jQuery('.number_columns_list').hide();
						jQuery('.featured_post_id').hide();
						jQuery('.number_columns').show();
					}
					else if(str == 'thumb_view_title_below'){
						jQuery('.number_columns_list').hide();
						jQuery('.featured_post_id').hide();
						jQuery('.number_columns').show();
					}
					else if(str == 'list_view_50_50'){
						jQuery('.number_columns_list').show();
						jQuery('.featured_post_id').hide();
						jQuery('.number_columns').hide();
					}
					else if(str == 'grid_view_featured_post'){
						jQuery('.number_columns_list').hide();
						jQuery('.featured_post_id').show();
						jQuery('.number_columns').show();
					}
					else if(str == 'grid_view'){
						jQuery('.number_columns_list').hide();
						jQuery('.featured_post_id').hide();
						jQuery('.number_columns').show();
					}
					else if(str == 'grid_mosaic'){
						jQuery('.number_columns_list').hide();
						jQuery('.featured_post_id').hide();
						jQuery('.number_columns').show();
					}
					else if(str == 'grid_50_50'){
						jQuery('.number_columns_list').hide();
						jQuery('.featured_post_id').hide();
						jQuery('.number_columns').show();
					}
				});


			});
			var elems = '';
			if(jQuery('#widgets-right .text_color_picker_c, .inactive-sidebar .text_color_picker_c').length > 0){
				elems = jQuery('#widgets-right .text_color_picker_c, .inactive-sidebar .text_color_picker_c');
			}else{
				elems = jQuery('.text_color_picker_c');
			}


			var widget_id = jQuery('div.widget');
			
				jQuery(document).ready(function ($) {
					if(typeof(wpColorPicker) == 'function'){
						jQuery(document).on( 'ready widget-updated widget-added', function() {	
							elems.wpColorPicker();
						});
					}

				});
			
			
		</script>

	<?php
	}
}
?>
