<?php

class widget_flo_view_types extends WP_Widget
{

	function widget_flo_view_types()
	{
		$widget_ops = array('classname' => 'flo_view_types', 'description' => __('Flo Latest Posts', 'flotheme'));
		$this->WP_Widget('widget_cosmo_flo_view_types', _TN_ . ' : ' . __('Flo Posts Types', 'flotheme'), $widget_ops);
	}

	function widget($args, $instance)
	{
		/* prints the widget*/
		extract($args, EXTR_SKIP);

		if (isset($instance['title'])) {
			$title = $instance['title'];
		} else {
			$title = '';
		}

		if (isset($instance['decoration'])) {
			$decoration = $instance['decoration'];
		} else {
			$decoration = '';
		}

		if (isset($instance['select_view_type'])) {
			$select_view_type = $instance['select_view_type'];
		} else {
			$select_view_type = '';
		}
		if (isset($instance['post_type'])) {
			$post_type = $instance['post_type'];
		} else {
			$post_type = '';
		}
		if (isset($instance['category_p'])) {
			$category_p = $instance['category_p'];
		} else {
			$category_p = '';
		}
		if (isset($instance['category_g'])) {
			$category_g = $instance['category_g'];
		} else {
			$category_g = '';
		}
		if (isset($instance['page_ids'])) {
			$page_ids = $instance['page_ids'];
		} else {
			$page_ids = '';
		}
		if (isset($instance['number_posts'])) {
			$number_posts = $instance['number_posts'];
		} else {
			$number_posts = '';
		}
		if (isset($instance['number_columns'])) {
			$number_columns = $instance['number_columns'];
		} else {
			$number_columns = '';
		}
		if (isset($instance['gutter'])) {
			$gutter = $instance['gutter'];
		} else {
			$gutter = '';
		}
		if (isset($instance['number_columns_list'])) {
			$number_columns_list = $instance['number_columns_list'];
		} else {
			$number_columns_list = '';
		}
		if (isset($instance['featured_post_id'])) {
			$featured_post_id = $instance['featured_post_id'];
		} else {
			$featured_post_id = '';
		}
		if (isset($instance['number_columns_featured'])) {
			$number_columns_featured = $instance['number_columns_featured'];
		} else {
			$number_columns_featured = '';
		}
		if (isset($instance['pagination'])) {
			$pagination = $instance['pagination'];
		} else {
			$pagination = '';
		}

		if($category_p){
			$cat_p ='';
			if(is_array($category_p)){

				foreach($category_p as $cat){
					$cat_p .= $cat.",";
				}
			}else{
				$cat_p = $category_p;
			}
		}else{
			$cat_p = '';
		}
		if($category_g){
			$cat_g ='';
			if(is_array($category_g)){
				foreach($category_g as $cat){
					$cat_g .= $cat.",";
				}
			}else{
				$cat_g = $category_g;
			}
		}else{
			$cat_g = '';
		}

		if($page_ids){
			$pgs ='';
			if(is_array($page_ids)){
				foreach($page_ids as $cat_page){
					$pgs .= $cat_page.",";
				}
			}else{
				$pgs = $page_ids;
			}
		}else{
			$pgs = '';
		}

		if (isset($decoration) && is_numeric($decoration)) {
			$attachment_info = wp_get_attachment_image_src($decoration, 'full'); // get the image attachment from image ID
			$image_src       = $attachment_info[0];
			$image_src = aq_resize($image_src, 360, 360, true, true); //
		}else{
			$image_src       = '';
		}
		if ($select_view_type != '') {
			?>
				<?php if ( (isset($image_src) && $image_src !='') || (isset($title) && $title != '') ): ?>
					<div class="block heading-title">
						<div class="row">
							<article style="text-aling:center;" class="content">
								<?php if(isset($image_src) && $image_src !=''){?><img src="<?php echo $image_src;?>" alt=""><?php }?>
								<?php if(isset($title) && $title != ''){?><h3> <?php echo $title;?></h3><?php }?>
							</article>
						</div>
					</div>
				<?php endif ?>
				
			<?php

			echo do_shortcode('
					[flo_list_posts post_type="' . $post_type . '" decoration="'.$decoration.'" category_p="' . $cat_p . '" page_ids="'.$pgs.'" category_g="' . $cat_g . '" view_type="' . $select_view_type . '" number_columns="' . $number_columns . '" number_columns_featured="' . $number_columns_featured . '" number_posts="' . $number_posts . '" gutter="' . $gutter . '" featured_post_id="' . $featured_post_id . '" ][/flo_list_posts]'
			);
		}

	}

	function update($new_instance, $old_instance)
	{
		/*save the widget*/
		$instance = $old_instance;

		$instance['title']               = strip_tags($new_instance['title']);
		$instance['decoration']               = strip_tags($new_instance['decoration']);
		$instance['post_type']           = strip_tags($new_instance['post_type']);
		$instance['select_view_type']    = strip_tags($new_instance['select_view_type']);
		$instance['number_posts']        = strip_tags($new_instance['number_posts']);
		$instance['number_columns']      = strip_tags($new_instance['number_columns']);
		$instance['gutter']              = strip_tags($new_instance['gutter']);
		$instance['number_columns_featured']              = strip_tags($new_instance['number_columns_featured']);
		

		if(isset($new_instance['category_p'][""])){
			$instance['category_p']              = $new_instance['category_p'][""];
		}else{
			$instance['category_p']              = $new_instance['category_p'];
		}
		if(isset($instance['category_g'][""])){
			$instance['category_g']              = $new_instance['category_g'][""];
		}else{
			$instance['category_g']              = $new_instance['category_g'];
		}
		if(isset($instance['page_ids'][""])){
			$instance['page_ids']              = $new_instance['page_ids'][""];
		}else{
			$instance['page_ids']              = $new_instance['page_ids'];
		}

//		$instance['category_p']          = $new_instance['category_p'];
//		$instance['category_g']          = $new_instance['category_g'];
		$instance['number_columns_list'] = strip_tags($new_instance['number_columns_list']);
		$instance['featured_post_id']    = strip_tags($new_instance['featured_post_id']);
		$instance['pagination']          = strip_tags($new_instance['pagination']);

		return $instance;
	}

	function form($instance)
	{
		/* widget form in backend */
		$instance = wp_parse_args((array)$instance, array('title'               => '', 'decoration' => '', 'post_type' => '', 'select_view_type' => '', 'category_p' => array(), 'category_g' => array(), 'number_posts' => '', 'number_columns' => '', 'gutter' => '',
		                                                  'number_columns_list' => '', 'number_columns_list' => '', 'featured_post_id' => '', 'number_columns_featured' => '', 'pagination' => '', 'page_ids' => array()));

		$title                   = strip_tags($instance['title']);
		$decoration                   = strip_tags($instance['decoration']);
		$post_type               = strip_tags($instance['post_type']);
		$select_view_type        = strip_tags($instance['select_view_type']);
		$number_posts            = strip_tags($instance['number_posts']);
		$number_columns          = strip_tags($instance['number_columns']);
		$gutter                  = strip_tags($instance['gutter']);
		if(isset($instance['category_p'][""])){
			$category_p              = $instance['category_p'][""];
		}else{
			$category_p              = $instance['category_p'];
		}
		if(isset($instance['category_g'][""])){
			$category_g              = $instance['category_g'][""];
		}else{
			$category_g              = $instance['category_g'];
		}
		if(isset($instance['page_ids'][""])){
			$page_ids              = $instance['page_ids'][""];
		}else{
			$page_ids              = $instance['page_ids'];
		}
		if(!esc_attr($post_type)){
			$post_type = 'post';
		}
		$number_columns_list     = strip_tags($instance['number_columns_list']);
		$featured_post_id        = strip_tags($instance['featured_post_id']);
		$number_columns_featured = strip_tags($instance['number_columns_featured']);
		$pagination              = strip_tags($instance['pagination']);

		if (isset($decoration) && is_numeric($decoration)) {
			$attachment_info = wp_get_attachment_image_src($decoration, 'thumbnail'); // get the image attachment from image ID
			$image_src       = $attachment_info[0];
			$image_id        = $decoration;
		}
		$placeholder_img_src = get_template_directory_uri() . "/images/placeholder.png";

		wp_enqueue_media(); // need this for the image uploader
		?>
			<style type="text/css">

				.ui-autocomplete{
					z-index: 99999999!important;
				}
			</style>
		<p style="color: blue">
			<?php _e('This widget is recommended to be used only in full width sidebars where there is enough room to display the content.', 'flotheme'); ?>
		</p>
		<style type="text/css">
			.cmb2-list li
			{
				display: inline-block;
			}

			.cmb2-list li img
			{
				border: 1px solid #fff;
			}
		</style>

		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title', 'flotheme') ?>:
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
				       name="<?php echo $this->get_field_name('title'); ?>" type="text"
				       value="<?php echo esc_attr($title); ?>"/>
			</label>
		</p>

		<p class="form-field">
			<br><label><?php _e('Decoration image:', 'flotheme'); ?></label><br>
            <span class="meta-box-field fvisible hidden " style="display: inline;">
	            <div class="travel_block-actions">
		            <input type="hidden" class="hidden-id" name="<?php echo $this->get_field_name('image_url'); ?>"
		                   value="<?php if (isset($image_src) && !empty($image_src))
			                   echo esc_attr($image_src); ?>">

		            <input type="hidden" class="hidden-image-id" name="<?php echo $this->get_field_name('decoration'); ?>"
		                   value="<?php if (isset($image_id) && !empty($image_id))
			                   echo esc_attr($image_id); ?>">
		            <ul class="actions_travel" style="  float: right;position: relative;   top: -15px;">
			            <li><a href="javascript:void(0);" onclick="jQuery(this).parents('.travel_block-actions').find('.hidden-image-id').val(''); jQuery(this).parents('.travel_block-actions').find('.hidden-id').val(''); jQuery(this).parents('.travel_block-actions').find('img').attr('src','<?php echo $placeholder_img_src; ?>');"
			                   class=" dashicons dashicons-trash delete-flo-slide" title="Delete image"></a></li>
		            </ul>
		            <a href="#" class=upload_image_button1 onclick="flo_upload_image(jQuery(this));" title="Click on the image to upload a new one">
			            <img src="<?php if (isset($image_src) && !empty($image_src))
				            echo esc_attr($image_src); else echo $placeholder_img_src; ?>" class="upload-thumb"/>
		            </a>


		            <br>
	            </div>
            </span>
		</p>
		<span style="float: right;margin-bottom: 10px;margin-top: 10px;width: 100%;color: #CCC;">The image uploaded here will be cropped to 360x360 px</span>
		<script type="text/javascript">
			//			init_ui_slider('.ui_slider');
			function flo_upload_image(obj) {

				// Uploading files
				var image_gallery_frame;
				// If the media frame already exists, reopen it.
				if (image_gallery_frame) {
					image_gallery_frame.open();
					return;
				}

				// Create the media frame.
				image_gallery_frame = wp.media.frames.downloadable_file = wp.media({
					// Set the title of the modal.
					title: 'Add attachment',
					button: {
						text: 'Add this attachment',
					},
					multiple: false
				});

				// When an image is selected, run a callback.
				image_gallery_frame.on('select', function () {

					var selection = image_gallery_frame.state().get('selection');

					selection.map(function (attachment) {

						attachment = attachment.toJSON();

						if (attachment.id) {
							jQuery(obj).parent().find('.hidden-id').val(attachment.url); // add the image URL in the hidden input

							jQuery(obj).parent().find('.hidden-image-id').val(attachment.id); // add the image ID in the hidden input

							jQuery(obj).parent().find('img').attr("src", attachment.url);
							jQuery(obj).parent().find('.hidden-id').trigger('change');

						}

					});
				});
				// Finally, open the modal.
				image_gallery_frame.open();

			}
		</script>

		<p>
			<label for="<?php echo $this->get_field_id('post_type'); ?>"><?php _e('Post Type', 'flotheme') ?>:
				<select class="widefat select_post_type" onchange="change_select(jQuery(this))" id="<?php echo $this->get_field_id('post_type'); ?>" name="<?php echo $this->get_field_name('post_type'); ?>">
					<option value="post" <?php if (esc_attr($post_type) == 'post') {
						echo "selected='selected'";
					} ?>>Post
					</option>
					<option value="gallery" <?php if (esc_attr($post_type) == 'gallery') {
						echo "selected='selected'";
					} ?>>Gallery
					</option>
					<option value="page" <?php if (esc_attr($post_type) == 'page') {
						echo "selected='selected'";
					} ?>>Pages
					</option>
				</select>
			</label>
		</p>
		<?php

		$post_cats              = get_terms('category', array('hide_empty' => true));

		$select_post_categories = '<select multiple="multiple" class="widefat select_category post_cats" id="' . $this->get_field_id('category_p') . '" name="' . $this->get_field_name('category_p') . '[]">';
		foreach ($post_cats as $cat_p) {
			if (isset($category_p)) {
				if (in_array($cat_p->slug, $category_p)) {
					$attr_cat[$cat_p->slug] = "selected='selected'";
				} else {
					$attr_cat[$cat_p->slug] = '';
				}
			} else {
				$attr_cat[$cat_p->slug] = '';
			}
			$select_post_categories .= '<option ' . $attr_cat[$cat_p->slug] . ' value="' . $cat_p->slug . '">' . $cat_p->name . '</option>';
		}
		$select_post_categories .= '</select>';


		$gallery_cats              = get_terms('gallery-category', array('hide_empty' => true));
		$select_gallery_categories = '<select multiple="multiple" class="widefat select_category gallery_cats"  id="' . $this->get_field_id('category_g') . '" name="' . $this->get_field_name('category_g') . '[]">';
		foreach ($gallery_cats as $cat_g) {
			if (isset($category_g)) {
				if (in_array($cat_g->slug, $category_g)) {
					$attr_cat[$cat_g->slug] = "selected='selected'";
				} else {
					$attr_cat[$cat_g->slug] = '';
				}
			} else {
				$attr_cat[$cat_g->slug] = '';
			}
			$select_gallery_categories .= '<option ' . $attr_cat[$cat_g->slug] . ' value="' . $cat_g->slug . '">' . $cat_g->name . '</option>';
		}
		$select_gallery_categories .= '</select>';

		$pages              = get_pages();
		$select_pages = '<select multiple="multiple" class="widefat select_pages pages"  id="' . $this->get_field_id('page_ids') . '" name="' . $this->get_field_name('page_ids') . '[]">';
		foreach ($pages as $pg) {

		if (isset($page_ids ) && $page_ids != '') {
				if (in_array($pg->ID, $page_ids)) {
					$attr_cat_p[$pg->ID] = "selected='selected'";
				} else {
					$attr_cat_p[$pg->ID] = '';
				}
			} else {
				$attr_cat_p[$pg->ID] = '';
			}
			$select_pages.= '<option ' . $attr_cat_p[$pg->ID] . ' value="' . $pg->ID . '">' . $pg->post_title . '</option>';
		}
		$select_pages .= '</select>';
		?>


		<style type="text/css">
			.cats_hd
			{
				display: none;
			}

			.cats_sh
			{
				display: block;
			}
		</style>
		<label class="lbl_to_change" for="<?php echo $this->get_field_id('category'); ?>">
		<span class="ttl"><?php if(esc_attr($post_type) != 'page'):_e('Category', 'flotheme');else: _e('Select pages ');endif; ?>:</span>
			<div class="to_change">
				<?php
				if (esc_attr($post_type) == 'post') {
					echo "<div class='posts cats_sh' >" . $select_post_categories . "</div>";
					echo "<div class='galleries cats_hd' >" . $select_gallery_categories . "</div>";
					echo "<div class='pages cats_hd' >" . $select_pages . "</div>";
				} elseif(esc_attr($post_type) == 'gallery') {
					echo "<div class='galleries cats_sh' >" . $select_gallery_categories . "</div>";
					echo "<div class='posts cats_hd' >" . $select_post_categories . "</div>";
					echo "<div class='pages cats_hd' >" . $select_pages . "</div>";
				}elseif(esc_attr($post_type) == 'page') {
					echo "<div class='pages cats_sh' >" . $select_pages . "</div>";
					echo "<div class='posts cats_hd' >" . $select_post_categories . "</div>";
					echo "<div class='galleries cats_hd' >" . $select_gallery_categories . "</div>";
				}
				?>
			</div>
		</label>
		</p>

		<p>
			<label for="<?php echo $this->get_field_id('select_view_type'); ?>"><?php _e('View Type', 'flotheme') ?>:

				<ul class="cmb2-radio-list cmb2-list">
					<li><input type="radio" <?php if (esc_attr($select_view_type) == 'thumb_view_title_over') {
							echo "checked";
						} ?> class="cmb2-option" name="<?php echo $this->get_field_name('select_view_type'); ?>" id="<?php echo $this->get_field_id('select_view_type'); ?>" value="thumb_view_title_over" style="display: none;">
						<img title="Thumbnail view title on hover" class="pattern-texture thumb_view_title_over" alt="Thumbnail view title on hover" src="<?php echo get_template_directory_uri(); ?>/flo-options/ReduxCore/assets/img/pattern/../icons/grid1.png">
					</li>
					<li><input type="radio" <?php if (esc_attr($select_view_type) == 'grid_view') {
							echo "checked";
						} ?> class="cmb2-option" name="<?php echo $this->get_field_name('select_view_type'); ?>" id="<?php echo $this->get_field_id('select_view_type'); ?>" value="grid_view" style="display: none;">
						<img title="Grid view" class="pattern-texture grid_view" alt="Grid view" src="<?php echo get_template_directory_uri(); ?>/flo-options/ReduxCore/assets/img/pattern/../icons/grid2.png" style="border: none;">
					</li>
					<li><input type="radio" <?php if (esc_attr($select_view_type) == 'grid_50_50') {
							echo "checked";
						} ?> class="cmb2-option" name="<?php echo $this->get_field_name('select_view_type'); ?>" id="<?php echo $this->get_field_id('select_view_type'); ?>" value="grid_50_50" style="display: none;">
						<img title="Grid 50x50" class="pattern-texture grid_50_50" alt="Grid 50x50" src="<?php echo get_template_directory_uri(); ?>/flo-options/ReduxCore/assets/img/pattern/../icons/grid3.png" style="border: none;">
					</li>
					<li><input type="radio" class="cmb2-option" <?php if (esc_attr($select_view_type) == 'grid_mosaic') {
							echo "checked";
						} ?> name="<?php echo $this->get_field_name('select_view_type'); ?>" id="<?php echo $this->get_field_id('select_view_type'); ?>" value="grid_mosaic" style="display: none;">
						<img title="Mosaic grid" class="pattern-texture grid_mosaic" alt="Mosaic grid" src="<?php echo get_template_directory_uri(); ?>/flo-options/ReduxCore/assets/img/pattern/../icons/grid4.png" style="border: none;">
					</li>
					<li><input type="radio" class="cmb2-option" <?php if (esc_attr($select_view_type) == 'list_view_50_50') {
							echo "checked";
						} ?> name="<?php echo $this->get_field_name('select_view_type'); ?>" id="<?php echo $this->get_field_id('select_view_type'); ?>" value="list_view_50_50" style="display: none;">
						<img title="List view 50x50" class="pattern-texture list_view_50_50" alt="List view 50x50" src="<?php echo get_template_directory_uri(); ?>/flo-options/ReduxCore/assets/img/pattern/../icons/grid5.png" style="border: none;">
					</li>
					<!-- <li><input type="radio" class="cmb2-option" <?php if (esc_attr($select_view_type) == 'thumb_view_title_below') {
							echo "checked";
						} ?> name="<?php echo $this->get_field_name('select_view_type'); ?>" id="<?php echo $this->get_field_id('select_view_type'); ?>" value="thumb_view_title_below" style="display: none;">
						<img title="Thumbnail view title below" class="pattern-texture thumb_view_title_below" alt="Thumbnail view title below" src="<?php echo get_template_directory_uri(); ?>/flo-options/ReduxCore/assets/img/pattern/../icons/grid6.png" style="border: none;">
					</li> -->
					<li><input type="radio" class="cmb2-option" <?php if (esc_attr($select_view_type) == 'grid_view_featured_post') {
							echo "checked";
						} ?> name="<?php echo $this->get_field_name('select_view_type'); ?>" id="<?php echo $this->get_field_id('select_view_type'); ?>" value="grid_view_featured_post" style="display: none;">
						<img title="Grid view with featured post" class="pattern-texture grid_view_featured_post" alt="Grid view with featured post" src="<?php echo get_template_directory_uri(); ?>/flo-options/ReduxCore/assets/img/pattern/../icons/grid7.png" style="border: none;">
					</li>
					<!-- <li><input type="radio" class="cmb2-option" <?php if (esc_attr($select_view_type) == 'grid_pattern') {
							echo "checked";
						} ?> name="<?php echo $this->get_field_name('select_view_type'); ?>" id="<?php echo $this->get_field_id('select_view_type'); ?>" value="grid_pattern" style="display: none;">
						<img title="Grid view pattern" class="pattern-texture grid_pattern" alt="Grid view pattern" src="<?php echo get_template_directory_uri(); ?>/flo-options/ReduxCore/assets/img/pattern/../icons/grid8.png" style="border: none;">
					</li> -->
				</ul>
				<div style="clear: both"></div>
			</label>
		</p>
		<p class="number_columns">
			<label for="<?php echo $this->get_field_id('number_columns'); ?>"><?php _e('Number of columns', 'flotheme') ?>:
				<select class="widefat" id="<?php echo $this->get_field_id('number_columns'); ?>" name="<?php echo $this->get_field_name('number_columns'); ?>">
					<option value="1" <?php if (esc_attr($number_columns) == '1') {
						echo "selected='selected'";
					} ?>>1
					</option>
					<option value="2" <?php if (esc_attr($number_columns) == '2') {
						echo "selected='selected'";
					} ?>>2
					</option>
					<option value="3" <?php if (esc_attr($number_columns) == '3') {
						echo "selected='selected'";
					} ?>>3
					</option>
					<option value="4" <?php if (esc_attr($number_columns) == '4') {
						echo "selected='selected'";
					} ?>>4
					</option>
					<option value="6" <?php if (esc_attr($number_columns) == '6') {
						echo "selected='selected'";
					} ?>>6
					</option>
				</select>
			</label>
		</p>

		<p class="number_columns_featured">
			<label for="<?php echo $this->get_field_id('number_columns_featured'); ?>"><?php _e('Number of columns featured', 'flotheme') ?>:
				<select class="widefat" id="<?php echo $this->get_field_id('number_columns_featured'); ?>" name="<?php echo $this->get_field_name('number_columns_featured'); ?>">
					<option value="3" <?php if (esc_attr($number_columns_featured) == '3') {
						echo "selected='selected'";
					} ?>>3
					</option>
					<option value="4" <?php if (esc_attr($number_columns_featured) == '4') {
						echo "selected='selected'";
					} ?>>4
					</option>
					<option value="6" <?php if (esc_attr($number_columns_featured) == '6') {
						echo "selected='selected'";
					} ?>>6
					</option>
				</select>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('number_posts'); ?>"><?php _e('Number of posts', 'flotheme') ?>:
				<input class="widefat" id="<?php echo $this->get_field_id('number_posts'); ?>" name="<?php echo $this->get_field_name('number_posts'); ?>" type="text" value="<?php echo $number_posts; ?>"/>
			</label>
		</p>
		<p class="featured_post_id_search">
				<input class="widefat generic-params" data-posttype="post" id="" name="" type="hidden" value="post"/>
		</p>
		<p class="featured_post_id">
			<?php 
				if(isset($featured_post_id) && is_numeric($featured_post_id)){
					$p_obj = get_post($featured_post_id);
					$p_name = $p_obj->post_title;
				}else{
					$p_name = '';
				}

			?>
			<label for="<?php echo $this->get_field_id('featured_post_id'); ?>"><?php _e('Featured post title', 'flotheme') ?>:
				<input class="widefat search_text_widget ui-autocomplete-input" onkeypress="search_posts_widget(jQuery(this))" data-posttype="post"  name="" type="text" value="<?php echo $p_name;?>"/>
				<span class="hint"><?php _e('begin typing the post name','flothme') ?></span>
			</label>
		</p>
		<p class="featured_post_id">
			<input class="widefat feat_post_id"  data-posttype="post" id="<?php echo $this->get_field_id('featured_post_id'); ?>" name="<?php echo $this->get_field_name('featured_post_id'); ?>" type="hidden" value="<?php echo $featured_post_id; ?>"/>
		</p>
		<p class="gutter">
			<label for="<?php echo $this->get_field_id('gutter'); ?>"><?php _e('Gutter', 'flotheme') ?>:
				<select class="widefat" id="<?php echo $this->get_field_id('gutter'); ?>" name="<?php echo $this->get_field_name('gutter'); ?>">
					<option value="gutter-default" <?php if (esc_attr($gutter) == 'default') {
						echo "selected='selected'";
					} ?>>Default 30px
					</option>
					<option value="gutter-0" <?php if (esc_attr($gutter) == 'gutter-0') {
						echo "selected='selected'";
					} ?>>No gutter
					</option>
					<option value="gutter-2" <?php if (esc_attr($gutter) == 'gutter-2') {
						echo "selected='selected'";
					} ?>>Gutter 2px
					</option>
					<option value="gutter-5" <?php if (esc_attr($gutter) == 'gutter-5') {
						echo "selected='selected'";
					} ?>>Gutter 5px
					</option>
					<option value="gutter-10" <?php if (esc_attr($gutter) == 'gutter-10') {
						echo "selected='selected'";
					} ?>>Gutter 10px
					</option>
					<option value="gutter-20" <?php if (esc_attr($gutter) == 'gutter-20') {
						echo "selected='selected'";
					} ?>>Gutter 20px
					</option>
					<option value="gutter-40" <?php if (esc_attr($gutter) == 'gutter-40') {
						echo "selected='selected'";
					} ?>>Gutter 40px
					</option>
					<option value="gutter-50" <?php if (esc_attr($gutter) == 'gutter-50') {
						echo "selected='selected'";
					} ?>>Gutter 50px
					</option>
				</select>
			</label>
		</p>

		<!-- <p class="pagination">
			<label for="<?php echo $this->get_field_id('pagination'); ?>"><?php _e('Pagination', 'flotheme') ?>:
				<select class="widefat" id="<?php echo $this->get_field_id('pagination'); ?>" name="<?php echo $this->get_field_name('pagination'); ?>">
					<option value="yes" <?php if (esc_attr($pagination) == 'yes') {
						echo "selected='selected'";
					} ?>>Yes
					</option>
					<option value="no" <?php if (esc_attr($pagination) == 'no') {
						echo "selected='selected'";
					} ?>>No
					</option>
				</select>
			</label>
		</p> -->

		<script type="text/javascript">

			jQuery('.cmb2-list li').on('click', 'img', function () {
				jQuery(this).parents('ul').find('li img').each(function () {
					jQuery(this).css({
						'border': 'none'
					})
				});

				jQuery(this).parent('li').find('input').click();

				jQuery(this).parent('li').find('img').css(
						{
							'border': '5px solid grey'
						}
				);
			});

			jQuery('.cmb2-radio-list li').find('input').each(function () {
				if (jQuery(this).is(':checked')) {
					jQuery(this).parent('li').find('img').css(
							{
								'border': '5px solid grey'
							}
					);
				}
			});

			var str = "";

			function only_hide(hide,obj){
				jQuery(obj).parents('.widget-content').find(hide).hide();
			}


			function only_show(show,obj){
				jQuery(obj).parents('.widget-content').find(show).show();
			}

			function show_hide() {
				jQuery(".cmb2-radio-list input:checked").each(function () {
					str = jQuery(this).val();
					var  hide,show, obj;
					obj = jQuery(this);
					if (str == 'thumb_view_title_over') {
						hide = '.featured_post_id, .number_columns_featured';
						show = '.number_columns, .gutter';
					}
					else if (str == 'thumb_view_title_below') {
						hide = '.number_columns';
						show = '.featured_post_id, .number_columns_featured';
					}
					else if (str == 'list_view_50_50') {
						hide = '.featured_post_id, .number_columns_featured, .number_columns,.gutter';
					}
					else if (str == 'grid_view_featured_post') {
						hide = '.number_columns';
						show = '.featured_post_id, .number_columns_featured, .gutter';
					}
					else if (str == 'grid_view') {
						hide = '.featured_post_id, .number_columns_featured';
						show = '.number_columns, .gutter';
					}
					else if (str == 'grid_mosaic') {
						hide = '.featured_post_id, .gutter, .number_columns_featured, .number_columns';
					}
					else if (str == 'grid_50_50') {
						hide = '.featured_post_id, .number_columns_featured';
						show = '.number_columns, .gutter';
					}
					else if (str == 'grid_pattern') {
						hide = '.featured_post_id, .gutter, .number_columns_featured, .number_columns';
					}
					if(hide && hide != ''){
						only_hide(hide,obj);
					}
					if(show && show != ''){
						only_show(show,obj);
					}
				});
			}

			show_hide();

			jQuery(".cmb2-radio-list").on("click", "img", function () {
				show_hide();
			});
		</script>
	<?php
	}
}

?>
