<?php

class widget_slideshow extends WP_Widget
{

	function widget_slideshow()
	{
		$widget_ops = array('classname' => 'widget_slideshow', 'description' => __(" Featured posts slider", 'flotheme'));
		$this->WP_Widget('widget_cosmo_slideshow', _TN_ . ': ' . __("Posts Slideshow", 'flotheme'), $widget_ops);
	}

	function widget($args, $instance)
	{
		/* prints the widget*/
		extract($args, EXTR_SKIP);

		if (isset($instance['title'])) {
			$title = $instance['title'];
		} else {
			$title = '';
		}
		if (isset($instance['post_type'])) {
			$post_type = $instance['post_type'];
		} else {
			$post_type = '';
		}
		if (isset($instance['category_p'])) {
			$category_p = $instance['category_p'];

		} else {
			$category_p = '';
		}
		if (isset($instance['category_g'])) {
			$category_g = $instance['category_g'];

		} else {
			$category_g = '';
		}
		if (isset($instance['nr_of_posts'])) {
			$nr_of_posts = $instance['nr_of_posts'];
		} else {
			$nr_of_posts = '';
		}
		if (isset($instance['excerpt_lenght'])) {
			$excerpt_lenght = $instance['excerpt_lenght'];
		} else {
			$excerpt_lenght = '';
		}
		if (isset($instance['spacing'])) {
			$spacing = $instance['spacing'];
		} else {
			$spacing = '';
		}
		if ($post_type == 'post') {
			$taxonomy = 'category';
		} else {
			$taxonomy = 'gallery-category';
		}
		if ($post_type == 'post') {
			if ($category_p != '') {
				$cat = $category_p;
			} else {
				$cats = get_terms('category', array(
						'orderby'    => 'count',
						'hide_empty' => 0,
				));
				foreach ($cats as $cat_p) {
					$cat[] = $cat_p->slug;
				}
			}

		} elseif ($post_type == 'gallery') {
			if (isset($category_g) && $category_g != '') {
				$cat = $category_g;
			} else {
				$cats = get_terms('gallery-category', array(
						'orderby'    => 'count',
						'hide_empty' => 0,
				));
				foreach ($cats as $cat_g) {
					$cat[] = $cat_g->slug;
				}
			}
		}
		if ($post_type != 'page') {
			$args = array(
					'posts_per_page'   => $nr_of_posts,
					'orderby'          => 'post_date',
					'order'            => 'DESC',
					'post_type'        => $post_type,
					'post_status'      => 'publish',
					'suppress_filters' => true,
					'tax_query'        => array(
							array(
									'taxonomy' => $taxonomy,
									'field'    => 'slug',
									'terms'    => $cat,
							)
					)
			);
		} else {
			$args = array(
					'posts_per_page'   => $nr_of_posts,
					'orderby'          => 'post_date',
					'order'            => 'DESC',
					'post_type'        => $post_type,
					'post_status'      => 'publish',
					'suppress_filters' => true,
			);
		}
		$posts_array = get_posts($args);

		//TODO Sliva  При отображении нужно учитывать $spacing и $excerpt_lenght

		?>
		<div class="block horizontal-slider">
			<div class="slider">

				<?php foreach ($posts_array as $item) { ?>
					<?php
					global $meta_color;
					if ($item->post_type == 'gallery') {
						$settings = meta::get_meta($item->ID, 'gallerytype');
						if (isset($settings['text_color']) && $settings['text_color'] != '') {
							$text_color = $settings['text_color'];
						} else {
							$text_color = NULL;
						}
						if (isset($settings['meta_color']) && $settings['meta_color'] != '') {
							$meta_color = $settings['meta_color'];
						} else {
							$meta_color = NULL;
						}
					} else {
						$settings = meta::get_meta($item->ID, 'settings');
						if (isset($settings['text_color']) && $settings['text_color'] != '') {
							$text_color = $settings['text_color'];
						} else {
							$text_color = NULL;
						}
						if (isset($settings['meta_color']) && $settings['meta_color'] != '') {
							$meta_color = $settings['meta_color'];
						} else {
							$meta_color = NULL;
						}
					}
					if (has_post_thumbnail($item->ID)) {
						$img_url1 = wp_get_attachment_url(get_post_thumbnail_id($item->ID), 'full'); //get img URL
						$img_url  = aq_resize($img_url1, 999999, 600, false, true); //crop img
					} else {
						$img_url = get_template_directory_uri() . '/images/aq_resize/noimage-600x600.jpg';
					} ?>

					<div class="slide" style="padding: 0 <?php echo $spacing;?>px 0 <?php echo $spacing;?>px">
						<figure >
							<img src="<?php echo $img_url ?>" alt="<?php echo $item->post_title; ?>"/>
							<?php
							global $attachment_info, $cont, $show_post_date, $post_id;

							$decor = options::get_value('blog_post', 'page_post_gallery-decoration');
							$meta = options::get_value('blog_post', 'meta');

							$type = $item->post_type;

							if ($type == 'gallery') {
								$meta = options::get_value('blog_post', 'gallery_meta');
							} else {
								$meta = options::get_value('blog_post', 'meta');
							}
							if ($cont) {
								$cont_class = ' page-header ';
							} else {
								$cont_class = '';
							}

							$terms = get_the_terms( $item->ID , $taxonomy );

							$cat_name = $terms[0]->name;
							$cat_link = get_term_link($terms[0]->slug, $taxonomy);
							?>
							<div class="figure-hover">
								<div class="inside">
									<?php if($cat_name):?>
										<h4 class="before-title"><a href="<?php if($cat_link):echo $cat_link;endif;?>"><?php echo $cat_name;?></a></h4>
									<?php endif;?>

									<h3 class="title"> <?php echo get_the_title($item->ID); ?></h3>
										<?php
										if($excerpt_lenght == ''){
											$excerpt_lenght = '100';
										}
										if(isset($excerpt_lenght)){
											$ln = $excerpt_lenght;
											if (!empty($item->post_excerpt)) {

												if (strlen(strip_tags(strip_shortcodes($item->post_excerpt))) > $ln) {
													echo '<div class="content">';
													echo mb_substr(strip_tags(strip_shortcodes($item->post_excerpt)), 0, $ln) . ' ...';
													echo "</div>";
												} else {
													echo '<div class="content">';
													echo strip_tags(strip_shortcodes($item->post_excerpt));
													echo "</div>";
												}
											} else {
												if (strlen(strip_tags(strip_shortcodes($item->post_content))) > $ln) {
													echo '<div class="content">';
													echo mb_substr(strip_tags(strip_shortcodes($item->post_content)), 0, $ln) . '  ...';
													echo "</div>";
												} else {
													if(!empty($item->post_content)){
														echo '<div class="content">';
														echo strip_tags(strip_shortcodes($item->post_content));
														echo "</div>";
													}
												}
											}
										}
										?>
									<a href="<?php echo get_the_permalink($item->ID);?>" class="btn read-more"><?php echo __('Read More','flotheme');?></a>
								</div>
							</div>
							<!-- end .post-header -->
						</figure>
					</div>
				<?php } ?>
			</div>

		</div>


	<?php
	}

	function update($new_instance, $old_instance)
	{
		/*save the widget*/
		$instance                   = $old_instance;
		$instance['title']          = strip_tags($new_instance['title']);
		$instance['post_type']      = strip_tags($new_instance['post_type']);
		$instance['category_p']     = $new_instance['category_p'];
		$instance['category_g']     = $new_instance['category_g'];
		$instance['nr_of_posts']    = strip_tags($new_instance['nr_of_posts']);
		$instance['excerpt_lenght'] = strip_tags($new_instance['excerpt_lenght']);
		$instance['spacing']        = strip_tags($new_instance['spacing']);
		return $instance;
	}

	function form($instance)
	{
		/* widget form in backend */
		$instance       = wp_parse_args((array)$instance, array('title' => '', 'post_type' => '', 'category_p' => array(), 'category_g' => array(), 'nr_of_posts' => '', 'excerpt_lenght' => '', 'spacing' => ''));
		$title          = strip_tags($instance['title']);
		$post_type      = strip_tags($instance['post_type']);
		$category_p     = $instance['category_p'];
		$category_g     = $instance['category_g'];
		$nr_of_posts    = strip_tags($instance['nr_of_posts']);
		$excerpt_lenght = strip_tags($instance['excerpt_lenght']);
		$spacing        = strip_tags($instance['spacing']);
		$post_cats      = get_terms('category', array('hide_empty' => true));

		$select_post_categories = '<select multiple="multiple" class="widefat select_category post_cats" id="' . $this->get_field_id('category_p') . '" name="' . $this->get_field_name('category_p') . '[]">';
		foreach ($post_cats as $cat_p) {
			if (isset($category_p)) {
				if (in_array($cat_p->slug, $category_p)) {
					$attr_cat[$cat_p->slug] = "selected='selected'";
				} else {
					$attr_cat[$cat_p->slug] = '';
				}
			} else {
				$attr_cat[$cat_p->slug] = '';
			}
			$select_post_categories .= '<option ' . $attr_cat[$cat_p->slug] . ' value="' . $cat_p->slug . '">' . $cat_p->name . '</option>';
		}
		$select_post_categories .= '</select>';

		$gallery_cats              = get_terms('gallery-category', array('hide_empty' => true));
		$select_gallery_categories = '<select multiple="multiple" class="widefat select_category gallery_cats"  id="' . $this->get_field_id('category_g') . '" name="' . $this->get_field_name('category_g') . '[]">';
		foreach ($gallery_cats as $cat_g) {
			if (isset($category_g)) {
				if (in_array($cat_g->slug, $category_g)) {
					$attr_cat[$cat_g->slug] = "selected='selected'";
				} else {
					$attr_cat[$cat_g->slug] = '';
				}
			} else {
				$attr_cat[$cat_g->slug] = '';
			}
			$select_gallery_categories .= '<option ' . $attr_cat[$cat_g->slug] . ' value="' . $cat_g->slug . '">' . $cat_g->name . '</option>';
		}
		$select_gallery_categories .= '</select>';
		?>
		<script type="text/javascript">
			jQuery(document).ready(function () {
				jQuery(".select_post_type").on('change', function () {
					var str = "";
					jQuery("option:selected", this).each(function () {
						str = jQuery(this).val();
						if (str === 'post') {
							jQuery('.to_change ').show();
							jQuery('.lbl_to_change').show();
							jQuery('.to_change ').find('div.galleries').addClass('cats_hd').removeClass('cats_sh');
							jQuery('.to_change ').find('div.posts').removeClass('cats_hd').addClass('cats_sh');
						} else if (str === 'gallery') {
							jQuery('.to_change ').show();
							jQuery('.lbl_to_change').show();
							jQuery('.to_change ').find('div.galleries').removeClass('cats_hd').addClass('cats_sh');
							jQuery('.to_change ').find('div.posts').removeClass('cats_sh').addClass('cats_hd');
						} else if (str === 'page') {
							jQuery('.to_change ').hide()
							jQuery('.lbl_to_change').hide()
//                            jQuery('.to_change ').find('div.posts').removeClass('cats_sh').addClass('cats_hd');
						}
					});
				});
			});
		</script>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title', 'flotheme') ?>:
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
				       name="<?php echo $this->get_field_name('title'); ?>" type="text"
				       value="<?php echo esc_attr($title); ?>"/>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('post_type'); ?>"><?php _e('Post Type', 'flotheme') ?>:
				<select class="widefat select_post_type" id="<?php echo $this->get_field_id('post_type'); ?>"
				        name="<?php echo $this->get_field_name('post_type'); ?>">
					<option value="post" <?php if (esc_attr($post_type) == 'post') {
						echo "selected='selected'";
					} ?>>Post
					</option>
					<option value="gallery" <?php if (esc_attr($post_type) == 'gallery') {
						echo "selected='selected'";
					} ?>>Gallery
					</option>
					<option value="page" <?php if (esc_attr($post_type) == 'page') {
						echo "selected='selected'";
					} ?>>Page
					</option>
				</select>
			</label>
		</p>
		<p>
			<style type="text/css">
				.cats_hd
				{
					display: none;
				}

				.cats_sh
				{
					display: block;
				}
			</style>
			<label class="lbl_to_change" for="<?php echo $this->get_field_id('category'); ?>"><?php _e('Category', 'flotheme') ?>:
				<div class="to_change">
					<?php if (esc_attr($post_type) == 'post') {
						echo "<div class='posts cats_sh' >" . $select_post_categories . "</div>";
						echo "<div class='galleries cats_hd' >" . $select_gallery_categories . "</div>";
					} else {
						echo "<div class='galleries cats_sh' >" . $select_gallery_categories . "</div>";
						echo "<div class='posts cats_hd' >" . $select_post_categories . "</div>";
					}?>
				</div>
			</label>
		</p>
		<p><label for="<?php echo $this->get_field_id('nr_of_posts'); ?>"><?php _e('Number of Posts', 'flotheme') ?>:</br>
				<input id="<?php echo $this->get_field_id('nr_of_posts'); ?>" type="text"
				       name="<?php echo $this->get_field_name('nr_of_posts'); ?>"
				       value="<?php echo esc_attr($nr_of_posts); ?>"/>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('excerpt_lenght'); ?>"><?php _e('Excerpt length', 'flotheme') ?>:</br>
				<input id="<?php echo $this->get_field_id('excerpt_lenght'); ?>" type="text"
				       name="<?php echo $this->get_field_name('excerpt_lenght'); ?>"
				       value="<?php echo esc_attr($excerpt_lenght); ?>"/>
			</label>
		</p>
		<p>
			<label for="<?php echo $this->get_field_id('spacing'); ?>"><?php _e('Spacing between images. (px)', 'flotheme') ?>:</br>
				<input id="<?php echo $this->get_field_id('spacing'); ?>" type="text"
				       name="<?php echo $this->get_field_name('spacing'); ?>"
				       value="<?php echo esc_attr($spacing); ?>"/>
			</label>
		</p>
	<?php
	}
}

?>
