<?php

class widget_video extends WP_Widget
{

    function widget_video()
    {
        $widget_ops = array('classname' => 'widget_video', 'description' => __("Video", 'flotheme'));
        $this->WP_Widget('widget_cosmo_video', _TN_ . ': ' . __("Video", 'flotheme'), $widget_ops);
    }

    function widget($args, $instance)
    {

        /* prints the widget*/
        extract($args, EXTR_SKIP);

        if (isset($instance['image'])) {
            $image = $instance['image'];
        } else {
            $image = '';
        }
        if (isset($instance['title'])) {
            $title = $instance['title'];
        } else {
            $title = '';
        }

        if (isset($instance['video_source'])) {
            $video_source = $instance['video_source'];
        } else {
            $video_source = '';
        }

        $image_src = '';

        if (isset($image) && is_numeric($image)) {
            $attachment_info = wp_get_attachment_image_src($image, 'full'); // get the image attachment from image ID
            $image_src = $attachment_info[0];
            $image_src = aq_resize($image_src, 1400, 662, true, true); //
        } else {
	        $image_src = get_template_directory_uri().'/images/aq_resize/noimage.jpg';
        }
        ?>

	        <div data-video-url="<?php echo $video_source;?>" class="block video-element">
		        <div class="row">
			        <div class="video columns medium-12"><a href="#" class="close">&times;</a>
                    <?php if ( (!isset($image) || !is_numeric($image)) && strlen($video_source) ): ?>
                        <?php  
                            $embed_code = wp_oembed_get($video_source);
                            echo $embed_code;
                        ?>
                    <?php else: ?>
                        <div class="video-container medium-12 columns">
                            <video controls preload="auto" class="video-js vjs-default-skin"></video>
                        </div>
                        <figure>
                            <div class="inner"><img src="<?php echo $image_src;?>" alt="">
                                <div class="figure-hover">
                                <a href="#" class="title"><i class="icon porto-ico-bold-arrow-right"> </i>
                                <span class="title-content"><?php echo $title;?></span></a>
                                </div>
                            </div>
                        </figure>
                    <?php endif ?>
				        
			        </div>
		        </div>
	        </div>
    <?php
    }

    function update($new_instance, $old_instance)
    {

        /*save the widget*/
        $instance = $old_instance;
        $instance['image'] = strip_tags($new_instance['image']);
        $instance['title'] = strip_tags($new_instance['title']);
        $instance['video_source'] = strip_tags($new_instance['video_source']);

        return $instance;
    }

    function form($instance)
    {
        /* widget form in backend */

        $instance = wp_parse_args((array)$instance, array('image' => '', 'title' => '',  'video_source' => '', 'link' => ''));

        $image = strip_tags($instance['image']);
        $title = strip_tags($instance['title']);
        $link = strip_tags($instance['link']);
        $video_source = strip_tags($instance['video_source']);

        if (isset($image) && is_numeric($image)) {
            $attachment_info = wp_get_attachment_image_src($image, 'thumbnail'); // get the image attachment from image ID
            $image_src = $attachment_info[0];
            $image_id = $image;
        }
        $placeholder_img_src = get_template_directory_uri() . "/images/placeholder.png";

        wp_enqueue_media(); // need this for the image uploader
        ?>
        <style type="text/css">
            .upload-thumb {
                max-width: 100px;
            }

        </style>
        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title ', 'flotheme') ?>:
                <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
                       name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo esc_attr($title); ?>">
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('video_source'); ?>"><?php _e('Video Url', 'flotheme') ?>:
                <textarea class="widefat" id="<?php echo $this->get_field_id('video_source'); ?>"
                          name="<?php echo $this->get_field_name('video_source'); ?>"
                          value="<?php echo esc_attr($video_source); ?>"><?php echo esc_attr($video_source); ?></textarea>
            </label>
        </p>

        <p class="form-field">
            <br><label><?php _e('Video Thumbnail Image:', 'flotheme'); ?></label><br>
            <span class="meta-box-field fvisible hidden " style="display: inline;">
	            <div class="travel_block-actions">
                    <input type="hidden" class="hidden-id" name="<?php echo $this->get_field_name('image_url'); ?>"
                           value="<?php if (isset($image_src) && !empty($image_src))
                               echo esc_attr($image_src); ?>">

                    <input type="hidden" class="hidden-image-id" name="<?php echo $this->get_field_name('image'); ?>"
                           value="<?php if (isset($image_id) && !empty($image_id))
                               echo esc_attr($image_id); ?>">

                    <a href="#" class=upload_image_button1 onclick="flo_upload_image(jQuery(this));"
                       title="Click on the image to upload a new one">
                        <img src="<?php if (isset($image_src) && !empty($image_src))
                            echo esc_attr($image_src); else echo $placeholder_img_src; ?>" class="upload-thumb"/>
                    </a>

                    <ul class="actions_travel">
                        <li><a href="javascript:void(0);"
                               onclick="jQuery(this).parents('.travel_block-actions').find('.hidden-image-id').val('').trigger('change'); jQuery(this).parents('.travel_block-actions').find('.hidden-id').val(''); jQuery(this).parents('.travel_block-actions').find('img').attr('src','<?php echo $placeholder_img_src; ?>');"
                               class=" dashicons dashicons-trash delete-flo-slide" title="Delete image"></a></li>
                    </ul>
                    <br>
                </div>
            </span>
        </p>
        <script type="text/javascript">
            function flo_upload_image(obj) {
	            console.log("SD");
                // Uploading files
                var image_gallery_frame;
                // If the media frame already exists, reopen it.
                if (image_gallery_frame) {
                    image_gallery_frame.open();
                    return;
                }

                // Create the media frame.
                image_gallery_frame = wp.media.frames.downloadable_file = wp.media({
                    // Set the title of the modal.
                    title: 'Add attachment',
                    button: {
                        text: 'Add this attachment',
                    },
                    multiple: false
                });

                // When an image is selected, run a callback.
                image_gallery_frame.on('select', function () {

                    var selection = image_gallery_frame.state().get('selection');

                    selection.map(function (attachment) {

                        attachment = attachment.toJSON();

                        if (attachment.id) {
                            jQuery(obj).parent().find('.hidden-id').val(attachment.url); // add the image URL in the hidden input

                            jQuery(obj).parent().find('.hidden-image-id').val(attachment.id); // add the image ID in the hidden input

                            jQuery(obj).parent().find('img').attr("src", attachment.url);
	                        jQuery(obj).parent().find('.hidden-id').trigger('change');
                        }

                    });
                });
                // Finally, open the modal.
                image_gallery_frame.open();

            }
        </script>
    <?php
    }
}
?>
