<?php
global $nr_of_columns, $flo_options,$post,$gutter;
$retina_ratio = 1;

// if flo_device_pixel_ratio cookie exists and it is >= 2, then we have a retina display,
// if(isset($_COOKIE["flo_device_pixel_ratio"]) && $_COOKIE["flo_device_pixel_ratio"] >=2 ){
// 	$retina_ratio = 2;
// }

$size_width = ReduxFramework::get_aqua_size('flo_title_over','width');
$size_height = ReduxFramework::get_aqua_size('flo_title_over','height');

if(isset($_COOKIE["flo_device_pixel_ratio"]) && $_COOKIE["flo_device_pixel_ratio"] >=2 ){
    $feat_img_obj = wp_get_attachment_metadata(get_post_thumbnail_id($post->ID));

    if( (isset($feat_img_obj['width']) && $feat_img_obj['width'] >= $size_width*2)  && 
        (isset($feat_img_obj['height']) && $feat_img_obj['height'] >= $size_height*2)
    ){
        $retina_ratio = 2;
    }

}

if (has_post_thumbnail($post->ID) && !post_password_required()) {
		$img_url1 = wp_get_attachment_url(get_post_thumbnail_id($post->ID), 'full'); //get img URL
		$img_url = aq_resize($img_url1, ReduxFramework::get_aqua_size('flo_title_over','width')*$retina_ratio, ReduxFramework::get_aqua_size('flo_title_over','height')*$retina_ratio, true, true); //crop img
}

if (!isset($img_url) || $img_url == '') {
	$img_url = get_template_directory_uri().'/images/aq_resize/noimage.jpg';
//	$img_url  = aq_resize($img_url1, ReduxFramework::get_aqua_size('flo_title_over','width')*$retina_ratio, ReduxFramework::get_aqua_size('flo_title_over','height')*$retina_ratio, true, true, true, 'noimage.jpg');
}

$block_class = get_col_class($nr_of_columns);

if($post->post_type == 'post'){
	$category = wp_get_post_terms($post->ID, 'category');
}else{
	$category = wp_get_post_terms($post->ID, 'gallery-category');
}

if ($category) {
    $cat_name = $category[0]->name;
    $cat_link = get_category_link($category[0]);
}else{
    $cat_name = '';
    $cat_link = '';
}
if (isset($flo_options) && $flo_options['flo-grid_reed_more_label'] != '') {
    $read_more_label = $flo_options['flo-grid_reed_more_label'];
} else {
    $read_more_label = 'read more';
}
?>

<div class="item columns <?php echo $block_class; ?>">
    <figure>
        <img style="margin: 0 auto;display: block" src="<?php echo $img_url; ?>" alt="">

        <div class="figure-hover">
            <div class="inside">
                <div class="description short-description">
                    <h4 class="before-title"><a href="<?php echo $cat_link; ?>"><?php echo $cat_name; ?></a></h4>

                    <h3 class="title"><a href="<?php echo get_the_permalink($post->ID) ?>"><?php echo flo_title($post->ID) ?></a></h3>
                    <a href="<?php echo get_permalink($post->ID) ?>"
                       class="read-more"><?php echo $read_more_label; ?></a></div>
            </div>

            <a href="<?php echo get_permalink($post->ID) ?>" class="grid-full-permalink"></a>
        </div>
    </figure>
</div>
