<?php
/**
 * The template for displaying the footer.
 *
 * Contains the closing of the #content div and all content after
 *
 * @package options_sample
 */

global $flo_options;

ob_start();
ob_clean();
get_sidebar('footer-first');
$f1 = ob_get_clean();

ob_start();
ob_clean();
get_sidebar('footer-global');
$f_global = ob_get_clean();

ob_start();
ob_clean();
get_sidebar('footer-third');
$f3 = ob_get_clean();

ob_start();
ob_clean();
get_sidebar('footer-fullscreen');
$ff = ob_get_clean();

ob_start();
ob_clean();
get_sidebar('footer-second');
$f2 = ob_get_clean();

ob_start();
ob_clean();
get_sidebar('footer-fifth');
$fw1 = ob_get_clean();

ob_start();
ob_clean();
get_sidebar('footer-fullwidth');
$fw2 = ob_get_clean();
?>


<footer class="main-footer">
	<?php if($fw1):?>
		<div class="row">
			<div class="columns medium-12 footer-full-widget">
				<?php echo $fw1;?>
			</div>
		</div>
	<?php endif;?>
	<?php if($ff):?>
		<div>
			<div class="footer-block columns medium-12 footer-full-widget">
				<div class="content">
					<?php echo $ff; ?>
				</div>
			</div>
		</div>
		<div style="clear: both"></div>
	<?php endif;?>

    <div class="row">
	    <?php if ($f1 || $f2 || $f3 || $fw1 || $fw2): ?>
				<div class="footer-columns-widgets">
	        <div class="footer-block columns medium-4">
	            <div class="content">
		            <?php echo $f1; ?>
	            </div>
	        </div>
	        <div class="footer-block columns medium-4">
	            <div class="content">
		            <?php echo $f2; ?>
	            </div>
	        </div>
	        <div class="footer-block columns medium-4">
	            <div class="content">
		            <?php echo $f3; ?>
	            </div>
	        </div>

	        <div class="widget-separators">
	        	<?php if ($f1): ?>	
		        	<div class="columns medium-4"></div>
	        	<?php endif ?>
						
						<?php if ($f2): ?>
		        	<div class="columns medium-4"></div>
						<?php endif ?>
						
						<?php if ($f3): ?>
		        	<div class="columns medium-4"></div>
						<?php endif ?>

	        </div>
	      </div>
	    <?php endif;?>
    </div>
	<?php if($fw2):?>
		<div class="row">
			<div class="columns medium-12 footer-full-widget">
				<?php echo $fw2;?>
			</div>
		</div>
	<?php endif;?>
	<?php if(isset($flo_options) && isset($flo_options['flo-enable_back_to_top_button']) && $flo_options['flo-enable_back_to_top_button'] == '1'):?>
		<div class="back-to-top-wrap">
			<a href="#" class="back-to-top porto-ico-small-arrow"></a>
		</div>
	<?php endif;?>
    <div class="row">
        <div class="copyright columns medium-12">
	        <?php
	        echo $f_global;
	        echo str_replace('%year%', date('Y'), $flo_options['opt-editor']); ?>
            <br/>
            <br/>
	        <?php
	            do_action( 'flo_footer_credits');
	        ?>
        </div>

    </div>
</footer>
</div>
<?php
echo $flo_options['flo-tracking_code'];
wp_footer(); 
?>
</body>
</html>
