<?php
/**
 * The main template file.
 *
 * This is the most generic template file in a WordPress theme
 * and one of the two required files for a theme (the other being style.css).
 * It is used to display a page when nothing more specific matches a query.
 * E.g., it puts together the home page when no home.php file exists.
 * Learn more: http://codex.wordpress.org/Template_Hierarchy
 *
 * @package options_sample
 */

get_header();

ob_start();
ob_clean();
get_sidebar('top_sidebar');
$st = ob_get_clean();
if($st):?>
	<div style="text-align: center" class="top_header_sidebar"><div class="columns medium-12"><?php echo $st;?></div></div>
<?php endif;?>

<?php if (have_posts()) : ?>

	<?php /* Start the Loop */ ?>

	<?php
	/* Include the Post-Format-specific template for the content.
	 * If you want to override this in a child theme, then include a file
	 * called content-___.php (where ___ is the Post Format name) and that will be used instead.
	 */
	cosmo_loop('archive', tools::primary_class(0, 'archive', $return_just_class = true));

		if (isset($flo_options) && isset($flo_options['flo-pagination_type']) && $flo_options['flo-pagination_type'] != '') {
			if ($flo_options['flo-pagination_type'] == 'small') {
				echo get_template_part('templates/template-pagination');
			} elseif ($flo_options['flo-pagination_type'] == 'next_prev') {
				echo get_template_part('templates/template-pagination_2');
			} elseif ($flo_options['flo-pagination_type'] == 'dots') {
				echo get_template_part('templates/template-pagination_3');
			}
		} else {
			echo get_template_part('templates/template-pagination');
		}
	?>

<?php else : ?>

	<?php get_template_part('content', 'none'); ?>


<?php endif; ?>


<?php get_footer(); ?>
