<?php
global $gallery_id,$flo_options;
if(isset($gallery_id) && $gallery_id != '' ){
	$post_id = $gallery_id;
}else{
	$post_id = $post->ID;
}
$post = get_post($post_id);
?>

<div class="gallery fixed-with-thumbs">
	<div class="row">
		<div class="gallery-nav">
			 <div class="columns medium-6">
            <?php
            if(isset($flo_options['flo-back_to_galleries_link'])  && $flo_options['flo-back_to_galleries_link'] != '' && isset($flo_options['flo-back_to_galleries_label']) && $flo_options['flo-back_to_galleries_label'] != ''){
                $gallery_back = get_post($flo_options['flo-back_to_galleries_link']);

            ?>
			   <a href="<?php echo get_the_permalink($gallery_back->ID);?>" class="back"><?php echo $flo_options['flo-back_to_galleries_label'];?></a>
            <?php }?>
       </div>
			<div class="columns medium-6 text-right">
				<?php get_template_part('parts/gallery/pagination_top'); ?>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="columns medium-12">
			<?php
			$post_image_gallery = get_post_meta($post->ID, '_post_image_gallery', true);
			if (strlen(trim($post_image_gallery))) {
			$img_id_array = array_filter(explode(',', $post_image_gallery));
			?>
			<div class="gallery-images">
				<ul class="slider with-arrows">
					<?php if (isset($img_id_array) && count($img_id_array) > 0) {
						$retina_ratio = 1;

						// if flo_device_pixel_ratio cookie exists and it is >= 2, then we have a retina display,
						if(isset($_COOKIE["flo_device_pixel_ratio"]) && $_COOKIE["flo_device_pixel_ratio"] >=2 ){
							$retina_ratio = 2;
						}
						$counter = 0;
						$size    = "list-view";
						//			ReduxFramework::get_aqua_size($size, 'height')
						foreach ($img_id_array as $key => $value) {
							$img_url           = wp_get_attachment_url($value, 'full'); //get img URL
							$image = aq_resize($img_url, 999999, ReduxFramework::get_aqua_size('flo-slides_desktop','height')*$retina_ratio, false, false); //resize img
							$attachment_info   = get_post($value); //deb::e($attachment_info );
							if(isset($attachment_info)){
								$caption           = $attachment_info->post_excerpt;
								$image_description = $attachment_info->post_content;
							}else{
								$caption           = '';
								$image_description = '';
							}


							$src               = $image[0]; // use original img src    for the first image
							$img_class         = '';
							$alt_title         = get_post_meta($value, '_wp_attachment_image_alt', true);
							?>
							<?php
							if ($counter < 5) {
								?>
								<li class="item">
									<figure><img src="<?php echo $src; ?>" alt="<?php echo $alt_title; ?>"/></figure>
								</li>
							<?php
							} else {
								?>
								<li class="item">
									<figure><img src="<?php echo get_template_directory_uri()?>/images/blank.gif" data-lazy="<?php echo $src; ?>" width="<?php echo $image[1]; ?>"
									             height="<?php echo $image[2]; ?>" alt="<?php echo $alt_title; ?>"></figure>
								</li>
							<?php
							}
							$counter++;
						}
					}?>
				</ul>

				<?php } ?>
				<div class="thumbs">
					<?php
					$post_image_gallery = get_post_meta($post->ID, '_post_image_gallery', true);
					if (strlen(trim($post_image_gallery))) {
						$img_id_array = array_filter(explode(',', $post_image_gallery));
						?>
						<ul class="thumbs-slider">
							<?php if (isset($img_id_array) && count($img_id_array) > 0) {
								$counter = 0;
								$size    = "list-view";
								//			ReduxFramework::get_aqua_size($size, 'height')
								foreach ($img_id_array as $key => $value) {
									$img_url           = wp_get_attachment_url($value, 'full'); //get img URL
									$image             = aq_resize($img_url, 116, 76, true, false); //resize img
									$attachment_info   = get_post($value); //deb::e($attachment_info );
									$caption           = $attachment_info->post_excerpt;
									$image_description = $attachment_info->post_content;
									$src               = $image[0]; // use original img src    for the first image
									$img_class         = '';
									$alt_title         = get_post_meta($value, '_wp_attachment_image_alt', true);
									?>
									<?php
									if ($counter < 5) {
										?>
										<li class="item">
											<figure><img src="<?php echo $src; ?>" alt="<?php echo $alt_title; ?>"/></figure>
										</li>
									<?php
									} else {
										?>
										<li class="item">
											<figure><img src="0" data-lazy="<?php echo $src; ?>" width="<?php echo $image[1]; ?>"
											             height="<?php echo $image[2]; ?>" alt="<?php echo $alt_title; ?>"></figure>
										</li>
									<?php
									}
									$counter++;
								}
							}?>
						</ul>

					<?php } ?>
					<div class="sub-thumbs">
						<a href="#" class="hide-thumbs"> <span class="hide-text">Hide thumbs</span><span class="show-text">Show thumbs</span></a>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="row">
		<div class="gallery-info under-slider">
			<div class="columns medium-6">
				<div class="description">
					<h3 class="gallery-name entry-title"><?php echo flo_title($post->ID); ?></h3>
				</div>
			</div>
			<?php
			$gal_social_sharing = $flo_options['flo-social_for_galleries'];

			if($gal_social_sharing == '1'){
				get_template_part('parts/social-sharing');
			}
			?>
			<div class="columns medium-12">
				<?php if ($post->post_content): ?>
					<div class="excerpt">
						<?php the_content(); ?>
					</div>
				<?php endif ?>
			</div>
		</div>
	</div>
</div>
