<?php
global $flo_options;
$header_class = $logo_position = $nav_class = $logo_class = $logo_in_nav_block = '';

if(isset($flo_options) && isset($flo_options['flo-header_type']) && $flo_options['flo-header_type'] != ''){

    $header_type = $flo_options['flo-header_type'];

    if($header_type == 'header_logo_outside'){

        $logo_class = ' columns medium-12 position-static ';
        $nav_class = ' columns medium-12 ';
        $logo_in_nav_block = false;
        $logo_position = ' logo-center-top ';

    }elseif($header_type == 'header_hamburger'){

        $logo_in_nav_block = true;
        $logo_class = ' columns medium-3 vertical-center ';
        $nav_class = ' columns medium-8 vertical-center ';
        $header_class = ' menu-slide-down ';

    }elseif($header_type == 'header_logo_inside'){

        if(isset($flo_options) && isset($flo_options['flo-logo_position']) && $flo_options['flo-logo_position'] != ''){

            $position = $flo_options['flo-logo_position'];
            if($position == '1'){
                $logo_in_nav_block = true;
                $logo_class = ' columns medium-3 vertical-center ';
                $nav_class = ' columns medium-9 vertical-center ';
                $logo_position = ' logo-left vertical-center ' ;
            }elseif($position == '3'){

                $logo_in_nav_block = true;
                $logo_class = ' columns medium-3 medium-push-9 text-right vertical-center ';
                $nav_class = ' columns medium-9 medium-pull-3 vertical-center ';
                $logo_position = ' logo-right vertical-center ';
            }
            elseif($position == '2'){
                $logo_in_nav_block = true;
	            $menu_locations = get_nav_menu_locations();

	            $nav_class = 'columns medium-12';
	            $logo_position = ' logo_center ';
            }
        }
    }
}
ob_start();
ob_clean();
get_sidebar('header-translation');
$sidebar_translate = ob_get_clean();

$show_top_nav = ($sidebar_translate || (isset($flo_options) && isset($flo_options['flo-search_on_header'])
                            && $flo_options['flo-search_on_header'] == '1') || (isset($flo_options) && isset($flo_options['flo-social_on_header'])
                            && $flo_options['flo-social_on_header'] == '1') || $header_type != 'header_logo_inside');

?>
 <header class="main-header menu-full <?php echo $logo_position.' '.$header_class;?>">
    <div class="mobile-elements">
        <div class="menu-selecter">
            <a href="#" class="open-menu"></a>
        </div>

        <div class="mobile-logo">
            <?php echo flo_get_logo(true); ?>
        </div>
    </div>
    
    <div class="all-navigation">
        <?php if($show_top_nav):?>
            <div class="top-nav desktop">
                    <div class="row">
                        <div class="columns medium-4">
                            <?php if (isset($flo_options) && isset($flo_options['flo-search_on_header']) && $flo_options['flo-search_on_header'] == '1'): ?>
                                    <div class="search-form">
                                        <?php echo get_template_part('searchform'); ?>
                                    </div>
                            <?php endif; ?>
                        </div>
                        <?php if($logo_in_nav_block != true && !isset($menu_locations['primary'])):?>
                            <div class="columns medium-4">
                                <?php echo flo_get_logo(); ?>
                            </div>
                        <?php endif;?>
                        <div class="columns medium-4 text-right">
                            <div class="second-nav">
                                <div class="language-select">
                                    <?php  dynamic_sidebar('header-translation');?>
                                </div>
                                <?php if (isset($flo_options) && isset($flo_options['flo-social_on_header']) && $flo_options['flo-social_on_header'] == '1') { ?>
                                    <?php
                                    echo get_template_part('parts/social_links');
                                    ?>
                                <?php } ?>
                            </div>
                        </div>
                    </div>
            </div>
        <?php endif;?>
        <div class="navigation-block">  
            <div class="row">

                <?php if($logo_in_nav_block != false && !isset($menu_locations['primary'])):?>
                    <div class="<?php echo $logo_class;?>">
                        <?php echo flo_get_logo(); ?>
                    </div>
                <?php endif;?>

                <?php
                    if(isset($flo_options) && isset($flo_options['flo-enable_menu_description']) && $flo_options['flo-enable_menu_description'] == 1){
                        $description_class = "with-sub-title";
                    } else {
                        $description_class = " ";
                    }
                ?>

                <div class="<?php echo $nav_class;?>">
                    <nav role="navigation" class="header_main-nav <?php echo $description_class; ?>">
                        <?php
                        $menu_class = 'header_main-nav_link';

                        if (isset($menu_locations['primary'])) {
                            $the_menu_object = wp_get_nav_menu_object($menu_locations['primary']);
                        }
                        if (isset($the_menu_object->slug)) {
                            add_filter('wp_nav_menu_' . $the_menu_object->slug . '_items', 'flo_add_menu_to_nav', 10, 2);
                        }
                        if (isset($the_menu_object->slug)) {
                            echo menu('primary', array('number-items' => options::get_value('menu', 'header'), 'current-class' => 'active', 'type' => 'category', 'class' => $menu_class, 'menu_id' => 'menu', 'nr_items_per_column' => 999));
                        }else{
                            $nr_items_per_column = 9999;
                            echo menu('primary', array('number-items' => options::get_value('menu', 'header'), 'submenu-class' => 'menu-item-has-children', 'current-class' => 'active', 'type' => 'category', 'class' => $menu_class, 'menu_id' => 'desktop_menu', 'nr_items_per_column' => $nr_items_per_column));
                        }
                        ?>
                    </nav>
                </div>

                <?php if ($header_type == 'header_hamburger'): ?>
                    <div class="columns medium-1 vertical-center">
                         <a href="#" class="menu-open"></a>
                    </div>
                <?php endif ?>
            </div>
        </div>

        <?php if($show_top_nav):?>
            <div class="top-nav mobile">
                <div class="row">
                    <div class="columns medium-4">
                        <?php if (isset($flo_options) && isset($flo_options['flo-search_on_header']) && $flo_options['flo-search_on_header'] == '1'): ?>
                                <div class="search-form">
                                    <?php echo get_template_part('searchform'); ?>
                                </div>
                        <?php endif; ?>
                    </div>
                    <?php if($logo_in_nav_block != true && !isset($menu_locations['primary'])):?>
                        <div class="columns medium-4">
                            <?php echo flo_get_logo(); ?>
                        </div>
                    <?php endif;?>
                    <div class="columns medium-4 text-right">
                        <div class="second-nav">
                            <div class="language-select">
                                <?php  dynamic_sidebar('header-translation');?>
                            </div>
                            <?php if (isset($flo_options) && isset($flo_options['flo-social_on_header']) && $flo_options['flo-social_on_header'] == '1') { ?>
                                <?php
                                echo get_template_part('parts/social_links');
                                ?>
                            <?php } ?>
                        </div>
                    </div>
                </div>
            </div>
        <?php endif;?>
    </div>


</header>

