<?php

global $flo_options;
/* post taxonomy */
$tax = $flo_options['flo-similar_criteria'];
$layout = meta::get_meta($post->ID, 'layout');

$settings = meta::get_meta($post->ID, 'settings');

$label = __('RELATED POSTS', 'flotheme');
$query = similar_query($post->ID, $tax, 3);

if (!empty($query)) {
	$result = $query->posts;
}

$post_type = get_post_type($post->ID);

$related_posts_label = __('RELATED POSTS', 'flotheme');


if (!empty($result)) {
	?>
	<div id="related-box" class="columns medium-12 related-box">
		<h3 id="related-title" class="related-title" style="padding-bottom: 20px;text-align: center"><?php echo $related_posts_label; ?></h3>

		<div class="row">

			<?php foreach ($result as $post): ?>

				<div class="small-12 medium-4 large-4 columns item">
					
							<?php if (has_post_thumbnail($post->ID) && !post_password_required()):
								$img_url1 = wp_get_attachment_url(get_post_thumbnail_id($post->ID), 'full'); //get img URL
								if ($img_url1) {
									$img_url = aq_resize($img_url1, 400, 300, true, true); //crop img
								}
								if (get_post_meta(get_post_thumbnail_id($post->ID), '_wp_attachment_image_alt', true)) {
									$alt_title = get_post_meta(get_post_thumbnail_id($post->ID), '_wp_attachment_image_alt', true);
								} else {
									$alt_title = $post->post_title;
								}
								?>
								<a href="<?php echo get_the_permalink($post->ID); ?>">
									<img src="<?php echo $img_url; ?>" class="attachment-post-thumbnail wp-post-image" alt="<?php echo $alt_title; ?>"/>
								</a>
							<?php else: ?>
								<?php $img_url_1 = get_template_directory_uri() . '/images/aq_resize/noimage-400x300.jpg';
								if (get_post_meta(get_post_thumbnail_id($post->ID), '_wp_attachment_image_alt', true)) {
									$alt_title = get_post_meta(get_post_thumbnail_id($post->ID), '_wp_attachment_image_alt', true);
								} else {
									$alt_title = $post->post_title;
								}
								?>
								<a href="<?php echo get_the_permalink($post->ID); ?>">
									<img src="<?php echo $img_url_1; ?>" class="attachment-post-thumbnail wp-post-image" alt="<?php echo $alt_title; ?>"/>
								</a>
							<?php endif;?>

							
						<h4 class="page-title entry-title">
							<a href="<?php echo get_the_permalink($post->ID); ?>">
								<?php echo the_title(); ?>
							</a>
						</h4>

						
					<!-- end .post-preview -->
					<!-- end .article -->

				</div>

			<?php endforeach; ?>
		</div>
		<!-- end .row -->

	</div>
	<?php

	wp_reset_postdata();
}
?>


