<?php
/*
Template Name: Latest post types
*/
global $flo_options, $meta;



$post_id = $post->ID;
$layout = meta::get_meta($post_id, 'layout');

if (isset($layout['type']) && $layout['type'] != 'full') {
    $content_width_class = tools::primary_class($post_id, 'blog_posts', $return_just_class = true);
} else {
    $content_width_class = tools::primary_class(0, 'blog_posts', $return_just_class = true);
}
$meta = meta::get_meta($post->ID, 'settings');
$show_header = $meta['page_title'];
$decoration = meta::get_meta($post->ID, 'uploader_custom');
$decor_image = get_post($decoration);
$decor_image_src = aq_resize($decor_image->guid, 200, 200, true, true, false);

get_header();


ob_start();
ob_clean();
get_sidebar('top_sidebar');
$st = ob_get_clean();
if($st):?>
	<div style="text-align: center" class="top_header_sidebar"><div class="columns medium-12"><?php echo $st;?></div></div>
<?php endif;?>

<div class="row ">
    <?php while (have_posts()): the_post();?>
        <div class="columns page-content <?php echo $content_width_class; ?>">

            <?php if ( ($decor_image_src && strlen(trim($decor_image_src)) ) || $show_header == 'yes' ): ?> 
                <div class="page-header">
                    <?php if(isset($decor_image_src) && $decor_image_src != ''):?>
                        <div class="header-icon"><img src="<?php echo $decor_image_src; ?>" alt=""></div>
                    <?php endif;?>
        	        <?php if ($show_header == 'yes'):?>
        	            <h1 class="entry-title page-title"><?php echo flo_title($post->ID); ?></h1>
        	        <?php endif;?>
                </div>
            <?php endif ?>


            <article class="content">
                <?php echo the_content();?>
            </article>

            <?php
                wp_reset_postdata();
	            $view_type = meta::get_meta($post->ID, '_cmb2_view_type');
	            $nr_of_columns = meta::get_meta($post->ID, '_cmb2_nr_of_columns');
	            $nr_of_columns_featured = meta::get_meta($post->ID, '_cmb2_nr_of_columns_featured');
	            $nr_of_columns_grid_50_50 = meta::get_meta($post->ID, '_cmb2_nr_of_columns_grid_50_50');
	            $nr_nr_of_columns_grid_title_below = meta::get_meta($post->ID, '_cmb2_nr_of_columns_grid_title_below');
	            $big_feat_post = flo_get_col_featured_big($nr_of_columns_featured);
	            $nr_of_posts = meta::get_meta($post->ID, '_cmb2_nr_of_posts');
	            $masonry = meta::get_meta($post->ID, '_cmb2_masonry');
	            $post_type_c = meta::get_meta($post->ID, '_cmb2_post_type');
	            $featured_post_id = meta::get_meta($post->ID, '_cmb2_feat_post');
	            $gutter = meta::get_meta($post->ID, '_cmb2_gutter');
                $pages = meta::get_meta($post->ID, '_cmb2_page_ids');

                
                if (isset($post_type_c) && $post_type_c != '' && $post_type_c != NULL) {
    	            $post_type = $post_type_c;
                } else {
    	            $post_type = 'post';
                }



                $enable_pagination = meta::get_meta($post->ID, '_cmb2_pagination');
                if (isset($enable_pagination) && $enable_pagination == 'yes') {
                    $pag = 'true';
                } else {
                    $pag = 'false';
                }
                $view_type_class = flo_view_type_classes($view_type);
            if(isset($masonry) && $masonry == 'yes'){
	            $masonry_class = 'masonry-grid';
            }else{
	            $masonry_class = ' ';
            }

            $valid_view_types =  array(
                    'thumb_view_title_over',
                    'grid_view',
                    'grid_50_50',
                    'grid_mosaic',
                    'list_view_50_50',
                    //'thumb_view_title_below',
                    'grid_view_featured_post',
                    //'grid_pattern',
                );

            if(!in_array($view_type,$valid_view_types)){
                $view_type = 'list_view_50_50';
            }
            if($view_type == 'grid_mosaic' || $view_type == 'list_view_50_50'  || $view_type == 'grid_pattern'){
	            $gutter = '';
            }

            ?>

            <div class="block <?php echo $view_type_class.' gutter-'.$gutter.' '. $masonry_class; ?>">
                <div class="row">
                    <?php
                        if (get_query_var('paged')) {
                            $current = get_query_var('paged');
                        } elseif (get_query_var('page')) {
                            $current = get_query_var('page');
                        } else {
                            $current = 1;
                        }
                        $query_args = array(
                                'post_type'           => $post_type,
                                'paged'               => $current,
                                "posts_per_page"      => $nr_of_posts,
                                'ignore_sticky_posts' => 1,
                        );

                        if($post_type == 'post'){
                            $category_filter = meta::get_meta($post->ID, '_cmb2_category_p');

                            if(sizeof($category_filter)){
                                $query_args['tax_query'] = array(
                                    array('taxonomy' => 'category',
                                          'field'    => 'term_id',
                                          'terms'    => array_values($category_filter)
                                    )
                                );
                            }

                            //_cmb2_category_g
                        }elseif($post_type == 'gallery'){
                            $category_filter = meta::get_meta($post->ID, '_cmb2_category_g');

                            if(sizeof($category_filter)){
                                $query_args['tax_query'] = array(
                                    array('taxonomy' => 'gallery-category',
                                          'field'    => 'term_id',
                                          'terms'    => array_values($category_filter)
                                    )
                                );
                            }
                        }elseif (isset($post_type) && $pages && $post_type && $post_type == 'page') {
                            $query_args['post__in'] = $pages;
                        }
                        // for grid_view_featured_post we wamt to exclude the featured post from the main loop
                        if ($view_type == 'grid_view_featured_post'){
                            if(!isset($featured_post_id) || $featured_post_id == null){
                                $featured_post_id = '1';
                            }

                            $query_args['post__not_in'] = array($featured_post_id);
                        }

                        $the_query = new WP_Query($query_args);
                        $post_ids = array();
                        $i = $counter = 1;
                        $size_of_array = count($the_query->posts);
                    ?>

                    <?php if ($view_type == 'grid_view_featured_post'): ?>

                        <?php
                            $category_feat = wp_get_post_terms($featured_post_id, 'category');

                            if ($category_feat) {
                                $cat_name_feat = $category_feat[0]->name;
                                $cat_link_feat = get_category_link($category_feat[0]);
                            }else{
	                            $cat_link_feat = '';
	                            $cat_name_feat = '';
                            }


                            if (has_post_thumbnail($featured_post_id) && !post_password_required()) {
                                $feat_img_url1 = wp_get_attachment_url(get_post_thumbnail_id($featured_post_id), 'full'); //get img URL
                                $feat_img_url  = aq_resize($feat_img_url1, 700, 699, true, true); //crop img
                            }

                            if (!isset($feat_img_url) || $feat_img_url == '') {
                                $feat_img_url = get_template_directory_uri() . '/images/aq_resize/noimage.jpg';
//                              $feat_img_url  = aq_resize($feat_img_url1, '700', '699', true, true); //crop img
                            }
	                    global $big_feat_post,$feat_img_url,$cat_link_feat, $cat_name_feat,$featured_post_id;
	                    echo get_template_part('parts/featured_image_block');

                        ?>
                    <?php endif; ?>

                    <?php while ($the_query->have_posts()): $the_query->the_post(); ?>
                        <?php
                            if ($counter == $size_of_array) {
                                $last = true;
                            } else {
                                $last = false;
                            }
                            $counter++;
							if($view_type){
                                echo get_template_part('floshortcodes/' . $view_type);
							}
                            $i++;
                            $post_ids[] = $the_query->post->ID; 
                        ?>
                    <?php endwhile; wp_reset_postdata();?>
                </div>
            </div>
        </div>
    <?php endwhile; ?>

    <?php
    layout::side('right', $post->ID, 'blog_posts');
    layout::side('left', $post->ID, 'blog_posts');
    ?>

    <?php  
        if ($pag == "true") {
            if (isset($flo_options) && isset($flo_options['flo-pagination_type']) && $flo_options['flo-pagination_type'] != '') {
                if ($flo_options['flo-pagination_type'] == 'small') {
                    echo get_template_part('templates/template-pagination');
                } elseif ($flo_options['flo-pagination_type'] == 'next_prev') {
                    echo get_template_part('templates/template-pagination_2');
                } elseif ($flo_options['flo-pagination_type'] == 'dots') {
                    echo get_template_part('templates/template-pagination_3');
                }
            } else {
                echo get_template_part('templates/template-pagination');
            }
        }
    ?>
</div>
<div class="row ">
    <div class="columns 12">
        <?php

            if (isset($meta['include_below_page_content_sidebar']) && $meta['include_below_page_content_sidebar'] == 'yes') {
                get_template_part('parts/post/block-below-page-content');
            }
        ?>
    </div>
</div>

<?php get_footer(); ?>
