<?php
/*
Template Name: Blog List View
*/
global $flo_options, $meta;



$post_id = $post->ID;
$layout = meta::get_meta($post_id, 'layout');

if (isset($layout['type']) && $layout['type'] != 'full') {
	$content_width_class = tools::primary_class($post_id, 'blog_posts', $return_just_class = true);
} else {
	$content_width_class = tools::primary_class(0, 'blog_posts', $return_just_class = true);
}
$meta = meta::get_meta($post->ID, 'settings');
$show_header = $meta['page_title'];
$decoration = meta::get_meta($post->ID, 'uploader_custom');
$decor_image = get_post($decoration);
$decor_image_src = aq_resize($decor_image->guid, 200, 200, true, true, false);

get_header(); ?>

<div class="row ">
	<?php while (have_posts()): the_post();?>
		<div class="columns page-content <?php echo $content_width_class; ?>">
			
			<?php if ( ($decor_image_src && strlen(trim($decor_image_src)) ) || $show_header == 'yes' ): ?>
				<div class="page-header">
					<?php if (isset($decor_image_src) && strlen(trim($decor_image_src) )): ?>
						<div class="header-icon"><img src="<?php echo $decor_image_src; ?>" alt=""></div>
					<?php endif ?>
					
					<?php if ($show_header == 'yes'):?>
						<h1 class="entry-title page-title"><?php echo flo_title($post->ID); ?></h1>
					<?php endif;?>
				</div>
			<?php endif ?>
			
			<article class="content">
				<?php the_content();?>
			</article>

			<?php
			wp_reset_postdata();
			$nr_of_posts = meta::get_meta($post->ID, 'flo_blog_list_nr_of_posts');
			$post_type_c = meta::get_meta($post->ID, 'flo_blog_list_post_type');
			// if (isset($post_type_c) && $post_type_c != '' && $post_type_c != NULL) {
			// 	$post_type = $post_type_c;
			// } else {
				$post_type = 'post';
			//}
			$enable_pagination = meta::get_meta($post->ID, '_cmb2_pagination');
			if (isset($enable_pagination) && $enable_pagination == 'yes') {
				$pag = 'true';
			} else {
				$pag = 'false';
			}
			?>

			<div class="block flo-list-view">
				<div class="row">
					<?php
					if (get_query_var('paged')) {
						$current = get_query_var('paged');
					} elseif (get_query_var('page')) {
						$current = get_query_var('page');
					} else {
						$current = 1;
					}
					$query_args = array(
							'post_type'           => $post_type,
							'paged'               => $current,
							"posts_per_page"      => $nr_of_posts,
							'ignore_sticky_posts' => 1,
					);

					$category_filter = meta::get_meta($post->ID, '_flo_blog_list_category');

                    if(sizeof($category_filter)){

                        $query_args['tax_query'] = array(
                            array('taxonomy' => 'category',
                                  'field'    => 'term_id',
                                  'terms'    => array_values($category_filter)
                            )
                        );
                    }

					$the_query = new WP_Query($query_args);
					$post_ids = array();
					$i = $counter = 1;
					$size_of_array = count($the_query->posts);
					?>

					<?php while ($the_query->have_posts()): $the_query->the_post(); ?>
						<?php
						if ($counter == $size_of_array) {
							$last = true;
						} else {
							$last = false;
						}
						$counter++;
							echo get_template_part('floshortcodes/list-view');
						$i++;
						$post_ids[] = $the_query->post->ID;
						?>
					<?php endwhile; wp_reset_postdata();?>
				</div>
			</div>
		</div>
	<?php endwhile; ?>

	<?php
	layout::side('right', $post->ID, 'blog_posts');
	layout::side('left', $post->ID, 'blog_posts');
	?>

	<?php
	if ($pag == "true") {
		if (isset($flo_options) && isset($flo_options['flo-pagination_type']) && $flo_options['flo-pagination_type'] != '') {
			if ($flo_options['flo-pagination_type'] == 'small') {
				echo get_template_part('templates/template-pagination');
			} elseif ($flo_options['flo-pagination_type'] == 'next_prev') {
				echo get_template_part('templates/template-pagination_2');
			} elseif ($flo_options['flo-pagination_type'] == 'dots') {
				echo get_template_part('templates/template-pagination_3');
			}
		} else {
			echo get_template_part('templates/template-pagination');
		}
	}
	?>
</div>
<div class="row ">
	<div class="columns 12">
		<?php

		if (isset($meta['include_below_page_content_sidebar']) && $meta['include_below_page_content_sidebar'] == 'yes') {
			get_template_part('parts/post/block-below-page-content');
		}
		?>
	</div>
</div>

<?php get_footer(); ?>
